##############################################################################
#
# vc/src/tcl/autolevel.tcl
#
# Main AutoLevel screen --- used for row used for autolevelmanagegrade and 
#                           autolevelstandby states 
#
# 20050427 DEH - created
#
# Copyright (c) 2005 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Curve display
    frame .ftop.cutFill
    pack .cutFillDisp -in .ftop.cutFill -side bottom -anchor s -padx 5 -pady 5
    raise .cutFillDisp

    # header frame
    frame .ftop.cutFill.header
    label .ftop.cutFill.header.l1 -text "AUTOLEVEL PROGRAM"
    label .ftop.cutFill.header.l2 -text "Default Field" -font $small_font
    bind .ftop.cutFill.header.l1 <ButtonPress-1> \
        { beepOnce; post $DISP_CANVAS0_SIG 0 }
    bind .ftop.cutFill.header.l2 <ButtonPress-1> \
        { beepOnce; post $DISP_CANVAS0_SIG 0 }
    button .ftop.cutFill.header.zoomout -image zoomout \
        -command { beepOnce; post $DISP_BTN1_SIG 0 } \
        -background $color7 -activebackground $color7 \
        -bd 0
    button .ftop.cutFill.header.zoomin -image zoomin \
        -command { beepOnce; post $DISP_BTN1_SIG 1 } \
        -background $color7 -activebackground $color7 \
        -bd 0

#    pack .ftop.cutFill.header.zoomout -side left -padx 5 -anchor w
#    pack .ftop.cutFill.header.zoomin -side right -padx 5 -anchor e
    pack .ftop.cutFill.header.l1 -side top -anchor center -padx 10 -pady 0
    pack .ftop.cutFill.header.l2 -side top -anchor center -padx 10 -pady 0
    pack .ftop.cutFill.header -side top -fill both -expand yes

    # Slider and Nudge container
    frame .ftop.sn

    # Slider frame
    frame .ftop.sn.sliders
    pack .s0 -in .ftop.sn.sliders -side bottom
    raise .s0
    
    # Elevation frame
    frame .ftop.sn.elevations
    label .ftop.sn.elevations.bladeTag  -text "  Blade " -font $medium_font
    label .ftop.sn.elevations.blade    -text "0.871" -font $huge_font
    label .ftop.sn.elevations.gradeTag  -text "  Grade " -font $medium_font
    label .ftop.sn.elevations.grade     -text "0.871" -font $huge_font
    label .ftop.sn.elevations.nudgeTag  -text "  Nudge " -font $medium_font
    label .ftop.sn.elevations.nudge     -text "" -font $medium_font

    bind .ftop.sn.elevations.grade <ButtonPress-1> \
        { beepOnce; post $DISP_CANVAS0_SIG 1 }

    # Pack elevation frame
    pack .ftop.sn.elevations.bladeTag -side top
    pack .ftop.sn.elevations.blade -side top
    pack .ftop.sn.elevations.gradeTag -side top
    pack .ftop.sn.elevations.grade -side top
    pack .ftop.sn.elevations.nudgeTag -side top
    pack .ftop.sn.elevations.nudge -side top

    # Nudge frame
    frame .ftop.sn.nudges
    SnazzyButton::create .ftop.sn.nudges.toggle \
	     btnBlueMS4U btnBlueMS4D 0.5 \
		"beepOnce; post $DISP_BTN8_SIG 2" "Toggle"
    SnazzyButton::create .ftop.sn.nudges.up UpNudgeU \
       UpNudgeD 0.5 "beepOnce; post $DISP_BTN8_SIG 0"
    SnazzyButton::create .ftop.sn.nudges.down downNudgeU \
                     downNudgeD 0.5 "beepOnce; post $DISP_BTN8_SIG 1"

    # Pack nudge frame
    pack .ftop.sn.nudges.up -side top -padx 5
    pack .ftop.sn.nudges.toggle -side top 
    pack .ftop.sn.nudges.down -side bottom 


    # Pack .ftop.sn
    pack .ftop.sn.sliders -side bottom -pady 10
    pack .ftop.sn.elevations -side left
    pack .ftop.sn.nudges -side right -padx 10
    
    # Input frame
    frame .ftop.input

    # Exit button
    SnazzyButton::create .ftop.input.cancel btnExitKhakiSquareUp \
         btnExitKhakiSquareDown 0.5 \
        "beepOnce; post $DISP_BTN9_SIG 9" "Exit"

    # Open/Close menu buttons
    SnazzyButton::create .ftop.input.menuOpen btnBlueSquareUp \
         btnBlueSquareDown 0.5 \
        "beepOnce; post $DISP_BTN2_SIG 1" "Menu"
    SnazzyButton::create .ftop.input.menuClose btnExitKhakiSquareUp \
         btnExitKhakiSquareDown 0.5 \
        "beepOnce; post $DISP_BTN2_SIG 0" "Close\nMenu"


    # STOP/GO buttons
    frame .ftop.input.stopgo
    SnazzyButton::create .ftop.input.stopgo.stop btnBigStopU btnBigStopD 0.5 \
	"beepOnce; post $DISP_BTN0_SIG 0"
    SnazzyButton::create .ftop.input.stopgo.go btnBigGoU btnBigGoD 0.5 \
        "beepOnce; post $DISP_BTN0_SIG 1"
    pack .ftop.input.stopgo.go -side top

    # Pack input frame
    pack .ftop.input.stopgo -side right -anchor se -padx 5 -pady 5
    pack .ftop.input.cancel -side bottom -anchor sw -padx 5 -pady 5
    pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5

    # Menu frames
    frame .ftop.menu
    image create photo marrowfor -file ${tclPath}gif/menuarrowforward.gif
    image create photo marrowback -file ${tclPath}gif/menuarrowbackward.gif

    # Menu level 0 frame
    frame .ftop.menu.level0 -bd 1 -relief solid
    frame .ftop.menu.level0.fl -width 100 -height 40
    pack propagate .ftop.menu.level0.fl 0
    label .ftop.menu.level0.fl.l -text "Menu 0:" -font $medium_font

    frame .ftop.menu.level0.f0 -width 100 -height 60
    pack propagate .ftop.menu.level0.f0 0
    button .ftop.menu.level0.f0.b0 -text "Button0" -font $btn_font \
        -command { beepOnce; post $DISP_BTN3_SIG 0 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level0.f1 -width 100 -height 60
    pack propagate .ftop.menu.level0.f1 0
    button .ftop.menu.level0.f1.b1 -text "Button1" -font $btn_font \
        -command { beepOnce; post $DISP_BTN3_SIG 1 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level0.f2 -width 100 -height 60
    pack propagate .ftop.menu.level0.f2 0
    button .ftop.menu.level0.f2.b2 -text "Button2" -font $btn_font \
        -command { beepOnce; post $DISP_BTN3_SIG 2 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level0.f3 -width 100 -height 60
    pack propagate .ftop.menu.level0.f3 0
    button .ftop.menu.level0.f3.b3 -text "Button3" -font $btn_font \
        -command { beepOnce; post $DISP_BTN3_SIG 3 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2

    # Menu level 1 frame
    frame .ftop.menu.level1 -bd 1 -relief solid
    frame .ftop.menu.level1.fl -width 100 -height 40
    pack propagate .ftop.menu.level1.fl 0
    label .ftop.menu.level1.fl.l -text "Menu 1:" -font $medium_font
    label .ftop.menu.level1.m -image marrowfor

    frame .ftop.menu.level1.f0 -width 100 -height 60
    pack propagate .ftop.menu.level1.f0 0
    button .ftop.menu.level1.f0.b0 -text "Button0" -font $btn_font \
        -command { beepOnce; post $DISP_BTN4_SIG 0 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level1.f1 -width 100 -height 60
    pack propagate .ftop.menu.level1.f1 0
    button .ftop.menu.level1.f1.b1 -text "Button1" -font $btn_font \
        -command { beepOnce; post $DISP_BTN4_SIG 1 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level1.f2 -width 100 -height 60
    pack propagate .ftop.menu.level1.f2 0
    button .ftop.menu.level1.f2.b2 -text "Button2" -font $btn_font \
        -command { beepOnce; post $DISP_BTN4_SIG 2 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level1.f3 -width 100 -height 60
    pack propagate .ftop.menu.level1.f3 0
    button .ftop.menu.level1.f3.b3 -text "Button3" -font $btn_font \
        -command { beepOnce; post $DISP_BTN4_SIG 3 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2

    # Menu level 2 frame
    frame .ftop.menu.level2 -bd 1 -relief solid
    frame .ftop.menu.level2.fl -width 100 -height 40
    pack propagate .ftop.menu.level2.fl 0
    label .ftop.menu.level2.fl.l -text "Menu 2:" -font $medium_font

    frame .ftop.menu.level2.f0 -width 100 -height 60
    pack propagate .ftop.menu.level2.f0 0
    button .ftop.menu.level2.f0.b0 -text "Button0" -font $btn_font \
        -command { beepOnce; post $DISP_BTN5_SIG 0 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level2.f1 -width 100 -height 60
    pack propagate .ftop.menu.level2.f1 0
    button .ftop.menu.level2.f1.b1 -text "Button1" -font $btn_font \
        -command { beepOnce; post $DISP_BTN5_SIG 1 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level2.f2 -width 100 -height 60
    pack propagate .ftop.menu.level2.f2 0
    button .ftop.menu.level2.f2.b2 -text "Button2" -font $btn_font \
        -command { beepOnce; post $DISP_BTN5_SIG 2 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2
    frame .ftop.menu.level2.f3 -width 100 -height 60
    pack propagate .ftop.menu.level2.f3 0
    button .ftop.menu.level2.f3.b3 -text "Button3" -font $btn_font \
        -command { beepOnce; post $DISP_BTN5_SIG 3 } \
        -compound center -image "" \
        -width 100 -height 60 \
        -background $color7 -activebackground $color7 \
        -bd 2

    # Pack screen -expand yes
    pack .ftop.cutFill -side left -anchor e -fill both 
    pack .ftop.input -side bottom -anchor sw
    pack .ftop.sn -side top -pady 5 -fill both -expand yes
    
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {cancelBtn setupBtn closeMenu} {
	.ftop.input.cancel configure -text $cancelBtn
	.ftop.input.menuOpen configure -text $setupBtn
	.ftop.input.menuClose configure -text $closeMenu
        pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr

    proc actConfigureAutoLevelStandby { manualLbl manualText } {
        global big_font color7

	actConfigureNoMenu
        pack forget .ftop.input.stopgo.stop
        pack .ftop.input.stopgo.go -side bottom -anchor se
        pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5
        .ftop.input.menuOpen configure -state "normal"
	.ftop.input.menuOpen configure -background $color7 -activebackground $color7

        actConfigureHeader $manualLbl $big_font orange
#        CutFillDisp::actConfigureAutoLevelStandby $manualText
    }

    proc actConfigureAutoLevelError { manualLbl manualText } {
        global big_font

	actConfigureNoMenu
        pack forget .ftop.input.stopgo.stop
        pack .ftop.input.stopgo.go -side bottom -anchor se
        pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5
        .ftop.input.menuOpen configure -state "active"

        actConfigureHeader $manualLbl $big_font red
#        CutFillDisp::actConfigureAutoLevelStandby $manualText
    }

    proc actConfigureAutoLevelSetup { manualLbl manualText } {
        global big_font
        pack forget .ftop.input.stopgo.go

        actConfigureHeader $manualLbl $big_font "dark khaki"
#        CutFillDisp::actConfigureAutoLevelStandby $manualText
    }

    proc actConfigureAutoLevelManageGrade { autoLbl } {
        global big_font color6
        pack forget .ftop.input.stopgo.go
        pack .ftop.input.stopgo.stop -side bottom -anchor se
        pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5
        .ftop.input.menuOpen configure -state "disabled"
	.ftop.input.menuOpen configure -background $color6 -activebackground $color6

        actConfigureHeader $autoLbl $big_font LimeGreen
#        CutFillDisp::actConfigureAutoLevelManageGrade
    }

    proc actConfigureHeader { text__ font__ color__ } {
        global huge_font big_font target_platform

        #DEH: 060322 Borrowed this fix from RCM in AutoSteer
        #      TCL on the MPC5200 platform seems to swap
        #     the RGB values causing orange and red to be displayed as blue
        #     instead of the intended color.  This fix is intended to be
        #     temporary and eventually will need to be fixed once the 
        #     undelying TCL error is resolved.  This fix has also been 
        #     implemented in msbox.tcl
        set frameColor $color__ 
	set textColor $color__
        if { $target_platform == "A5"} {
          if { $color__ == "orange"} {
            set frameColor #00A5FF  
	      set textColor #FFA500
          }
          if { $color__ == "red"} {
            set frameColor #0000FF  
	      set textColor #FF0000
          } 
	  if { $color__ == "dark khaki" } {
	      set frameColor #60A7A4
	      set textColor #A4A760
	   }
        }
        
	
        eval {.ftop.cutFill.header.l1 configure -text $text__ -font} $font__\
            {-background $color__}
        eval {.ftop.cutFill.header.l2 configure -background $textColor}
       .ftop.cutFill.header configure -background $frameColor 
#        .ftop.cutFill.header.zoomout configure -background $color__ \
\#            -activebackground $color__
 #       .ftop.cutFill.header.zoomin configure -background $color__ \
 \#           -activebackground $color__
        .ftop.cutFill configure -background $frameColor
    }

    proc actConfigureFieldName { fieldname__ } {
	eval {.ftop.cutFill.header.l2 configure -text $fieldname__}
    }

    proc actConfigureMenu { } {
        pack forget \
            .ftop.input.menuOpen \
            .ftop.sn \
            .ftop.cpuload
        pack .ftop.input.menuClose -side bottom -anchor sw -padx 5 -pady 5
        pack .ftop.menu -side top -pady 5 -fill both -expand yes
    }

    proc actConfigureNoMenu {} {
        pack forget .ftop.input.menuClose \
            .ftop.menu .ftop.menu.level0 .ftop.menu.level1 .ftop.menu.level2
        pack .ftop.sn -side top -pady 10 -fill both -expand yes
        pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5
        .ftop.input.menuOpen configure -state "active"
        actUnHighlightMenuLevel 0
        actUnHighlightMenuLevel 1
        actUnHighlightMenuLevel 2
    }

    proc actConfigureCpuLoad {} {
        pack forget .ftop.input.menuClose \
            .ftop.menu .ftop.menu.level0 .ftop.menu.level1 .ftop.menu.level2
        pack .ftop.cpuload -side top -fill both -expand yes -pady 20
        pack .ftop.input.menuOpen -side bottom -anchor sw -padx 5 -pady 5
        .ftop.input.menuOpen configure -state "active"
        actUnHighlightMenuLevel 0
        actUnHighlightMenuLevel 1
        actUnHighlightMenuLevel 2
    }

    proc actConfigureMenuLevel0 { title__ \
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__ } {

        global color5 color7 color9
        pack forget \
            .ftop.menu.level1 \
            .ftop.menu.level2 \
            .ftop.menu.level0.l \
            .ftop.menu.level0.fl \
            .ftop.menu.level0.f0 \
            .ftop.menu.level0.f1 \
            .ftop.menu.level0.f2 \
            .ftop.menu.level0.f3 \
            .ftop.menu.level0.f0.b0 \
            .ftop.menu.level0.f1.b1 \
            .ftop.menu.level0.f2.b2 \
            .ftop.menu.level0.f3.b3

        .ftop.menu.level0.fl.l configure -text $title__
        pack .ftop.menu.level0.fl -side top -anchor n
        pack .ftop.menu.level0.fl.l -side top -anchor n

        if {$b0__ != "!"} {
            .ftop.menu.level0.f0.b0 configure -text $b0__ \
                -command "beepOnce; post \$DISP_BTN3_SIG $b0Id__" \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b0Id__ == 0} {
                .ftop.menu.level0.f0.b0 configure -state disabled \
                    -background $color9
            }
            if {$b0Hi__ >= 1} {
                .ftop.menu.level0.f0.b0 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level0.f0 -side top -anchor n
            pack .ftop.menu.level0.f0.b0 -side left -padx 2 -pady 5
        }
        if {$b1__ != "!"} {
            .ftop.menu.level0.f1.b1 configure -text $b1__ \
                -command " beepOnce; post \$DISP_BTN3_SIG $b1Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b1Id__ == 0} {
                .ftop.menu.level0.f1.b1 configure -state disabled \
                    -background $color9
            }
            if {$b1Hi__ >= 1} {
                .ftop.menu.level0.f1.b1 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level0.f1 -side top -anchor n
            pack .ftop.menu.level0.f1.b1 -side left -padx 2 -pady 5
        }
        if {$b2__ != "!"} {
            .ftop.menu.level0.f2.b2 configure -text $b2__ \
                -command " beepOnce; post \$DISP_BTN3_SIG $b2Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b2Id__ == 0} {
                .ftop.menu.level0.f2.b2 configure -state disabled \
                    -background $color9
            }
            if {$b2Hi__ >= 1} {
                .ftop.menu.level0.f2.b2 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level0.f2 -side top -anchor n
            pack .ftop.menu.level0.f2.b2 -side left -padx 2 -pady 5
        }
        if {$b3__ != "!"} {
            .ftop.menu.level0.f3.b3 configure -text $b3__ \
                -command " beepOnce; post \$DISP_BTN3_SIG $b3Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b3Id__ == 0} {
                .ftop.menu.level0.f3.b3 configure -state disabled \
                    -background $color9
            }
            if {$b3Hi__ >= 1} {
                .ftop.menu.level0.f3.b3 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level0.f3 -side top -anchor n
            pack .ftop.menu.level0.f3.b3 -side left -padx 2 -pady 5
        }

        pack .ftop.menu.level0 -side left -padx 5 -pady 5 -anchor nw

        # MLE-040130: Cheating; this should be done in C side
        global level0list
        set level0list \
            [list \
                 "$b0Id__ .ftop.menu.level0.f0 .ftop.menu.level0.f0.b0" \
                 "$b1Id__ .ftop.menu.level0.f1 .ftop.menu.level0.f1.b1" \
                 "$b2Id__ .ftop.menu.level0.f2 .ftop.menu.level0.f2.b2" \
                 "$b3Id__ .ftop.menu.level0.f3 .ftop.menu.level0.f3.b3" ]
    }

    proc actConfigureMeasureMenu { title__ meas__ measId__\
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__} {
        global color5 color7 color9
        if {$meas__ != "!"} {
            .ftop.menu.level0.f3.b3 configure -text $meas__ \
                -command " beepOnce; post \$DISP_BTN3_SIG $measId__" \
                -state normal -image "" \
                -background $color5 -activebackground $color5
            pack .ftop.menu.level0.f3 -side top -anchor n
            pack .ftop.menu.level0.f3.b3 -side left -padx 2 -pady 5
        }
	actConfigureMenuLevel1 $title__ $b0__ $b0Id__ $b0Hi__ $b1__ $b1Id__ $b1Hi__ $b2__ $b2Id__ $b2Hi__ $b3__ $b3Id__ $b3Hi__
    }

    proc actForgetMeasureBtn {} {
	pack forget .ftop.menu.level0.f3
    }

    proc actConfigureSlopeMenu { title__ \
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__} {
	actForgetMeasureBtn
	actConfigureMenuLevel1 $title__ $b0__ $b0Id__ $b0Hi__ $b1__ $b1Id__ $b1Hi__ $b2__ $b2Id__ $b2Hi__ $b3__ $b3Id__ $b3Hi__
    }

    proc actConfigureLaserGradeMenu { title__ tower__ towerId__\
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__} {
        global color5 color7 color9
        if {$tower__ != "!"} {
            .ftop.menu.level0.f3.b3 configure -text $tower__ \
                -command " beepOnce; post \$DISP_BTN3_SIG $towerId__" \
                -state normal -image "" \
                -background $color5 -activebackground $color5
            pack .ftop.menu.level0.f3 -side top -anchor n
            pack .ftop.menu.level0.f3.b3 -side left -padx 2 -pady 5
        }
	actConfigureMenuLevel1 $title__ $b0__ $b0Id__ $b0Hi__ $b1__ $b1Id__ $b1Hi__ $b2__ $b2Id__ $b2Hi__ $b3__ $b3Id__ $b3Hi__
    }

    proc actConfigureGPSMenu { title__ \
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__} {
	actForgetMeasureBtn
	actConfigureMenuLevel1 $title__ $b0__ $b0Id__ $b0Hi__ $b1__ $b1Id__ $b1Hi__ $b2__ $b2Id__ $b2Hi__ $b3__ $b3Id__ $b3Hi__
    }

    proc actConfigureMenuLevel1 { title__ \
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__} {

        global color5 color7 color9
        pack forget \
            .ftop.menu.level2 \
            .ftop.menu.level1.l \
            .ftop.menu.level1.fl \
            .ftop.menu.level1.f0 \
            .ftop.menu.level1.f1 \
            .ftop.menu.level1.f2 \
            .ftop.menu.level1.f3 \
            .ftop.menu.level1.f0.b0 \
            .ftop.menu.level1.f1.b1 \
            .ftop.menu.level1.f2.b2 \
            .ftop.menu.level1.f3.b3

        .ftop.menu.level1.fl.l configure -text $title__
        pack .ftop.menu.level1.fl -side top -anchor n
        pack .ftop.menu.level1.fl.l -side top -anchor n

        if {$b0__ != "!"} {
            .ftop.menu.level1.f0.b0 configure -text $b0__ \
                -command " beepOnce; post \$DISP_BTN4_SIG $b0Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b0Id__ == 0} {
                .ftop.menu.level1.f0.b0 configure -state disabled \
                    -background $color9
            }
            if {$b0Hi__ >= 1} {
                .ftop.menu.level1.f0.b0 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level1.f0 -side top -anchor n
            pack .ftop.menu.level1.f0.b0 -side left -padx 2 -pady 5
        }
        if {$b1__ != "!"} {
            .ftop.menu.level1.f1.b1 configure -text $b1__ \
                -command " beepOnce; post \$DISP_BTN4_SIG $b1Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b1Id__ == 0} {
                .ftop.menu.level1.f1.b1 configure -state disabled \
                    -background $color9
            }
            if {$b1Hi__ >= 1} {
                .ftop.menu.level1.f1.b1 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level1.f1 -side top -anchor n
            pack .ftop.menu.level1.f1.b1 -side left -padx 2 -pady 5
        }
        if { $b2__ != "!" } {
            .ftop.menu.level1.f2.b2 configure -text $b2__ \
                -command " beepOnce; post \$DISP_BTN4_SIG $b2Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b2Id__ == 0} {
                .ftop.menu.level1.f2.b2 configure -state disabled \
                    -background $color9
            }
            if {$b2Hi__ >= 1} {
                .ftop.menu.level1.f2.b2 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level1.f2 -side top -anchor n
            pack .ftop.menu.level1.f2.b2 -side left -padx 2 -pady 5
        }
        if { $b3__ != "!" } {
            .ftop.menu.level1.f3.b3 configure -text $b3__ \
                -command " beepOnce; post \$DISP_BTN4_SIG $b3Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b3Id__ == 0} {
                .ftop.menu.level1.f3.b3 configure -state disabled \
                    -background $color9
            }
            if {$b3Hi__ >= 1} {
                .ftop.menu.level1.f3.b3 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level1.f3 -side top -anchor n
            pack .ftop.menu.level1.f3.b3 -side left -padx 2 -pady 5
        }

        pack .ftop.menu.level1 -side left -padx 5 -pady 5 -anchor nw

        # MLE-040130: Cheating; this should be done in C side
        global level1list
        set level1list \
            [list \
                 "$b0Id__ .ftop.menu.level1.f0 .ftop.menu.level1.f0.b0" \
                 "$b1Id__ .ftop.menu.level1.f1 .ftop.menu.level1.f1.b1" \
                 "$b2Id__ .ftop.menu.level1.f2 .ftop.menu.level1.f2.b2" \
                 "$b3Id__ .ftop.menu.level1.f3 .ftop.menu.level1.f3.b3" ]
    }

    proc actConfigureMenuLevel2 { title__ \
                                      b0__ b0Id__ b0Hi__ \
                                      b1__ b1Id__ b1Hi__ \
                                      b2__ b2Id__ b2Hi__ \
                                      b3__ b3Id__ b3Hi__ } {

        global color5 color7 color9
        pack forget \
            .ftop.menu.level1 \
            .ftop.menu.level2.l \
            .ftop.menu.level2.fl \
            .ftop.menu.level2.f0 \
            .ftop.menu.level2.f1 \
            .ftop.menu.level2.f2 \
            .ftop.menu.level2.f3 \
            .ftop.menu.level2.f0.b0 \
            .ftop.menu.level2.f1.b1 \
            .ftop.menu.level2.f2.b2 \
            .ftop.menu.level2.f3.b3

        .ftop.menu.level2.fl.l configure -text $title__
        pack .ftop.menu.level2.fl -side top -anchor n
        pack .ftop.menu.level2.fl.l -side top -anchor n

        if {$b0__ != "!"} {
            .ftop.menu.level2.f0.b0 configure -text $b0__ \
                -command " beepOnce; post \$DISP_BTN5_SIG $b0Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b0Id__ == 0} {

                puts "at b0Id__ == 0"

                .ftop.menu.level2.f0.b0 configure -state disabled \
                    -background $color9
            }
            if {$b0Hi__ >= 1} {
                .ftop.menu.level2.f0.b0 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level2.f0 -side top -anchor n
            pack .ftop.menu.level2.f0.b0 -side left -padx 2 -pady 5
        }
        if {$b1__ != "!"} {
            .ftop.menu.level2.f1.b1 configure -text $b1__ \
                -command " beepOnce; post \$DISP_BTN5_SIG $b1Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b1Id__ == 0} {
                .ftop.menu.level2.f1.b1 configure -state disabled \
                    -background $color9
            }
            if {$b1Hi__ >= 1} {
                .ftop.menu.level2.f1.b1 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level2.f1 -side top -anchor n
            pack .ftop.menu.level2.f1.b1 -side left -padx 2 -pady 5
        }
        if {$b2__ != "!"} {
            .ftop.menu.level2.f2.b2 configure -text $b2__ \
                -command " beepOnce; post \$DISP_BTN5_SIG $b2Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b2Id__ == 0} {
                .ftop.menu.level2.f2.b2 configure -state disabled \
                    -background $color9
            }
            if {$b2Hi__ >= 1} {
                .ftop.menu.level2.f2.b2 configure \
                -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level2.f2 -side top -anchor n
            pack .ftop.menu.level2.f2.b2 -side left -padx 2 -pady 5
        }
        if {$b3__ != "!"} {
            .ftop.menu.level2.f3.b3 configure -text $b3__ \
                -command " beepOnce; post \$DISP_BTN5_SIG $b3Id__ " \
                -state normal -image "" \
                -background $color7 -activebackground $color7
            if {$b3Id__ == 0} {
                .ftop.menu.level2.f3.b3 configure -state disabled \
                    -background $color9
            }
            if {$b3Hi__ >= 1} {

                puts "at b3Hi__"

                .ftop.menu.level2.f3.b3 configure \
                    -background $color5 -activebackground $color5
            }
            pack .ftop.menu.level2.f3 -side top -anchor n
            pack .ftop.menu.level2.f3.b3 -side left -padx 2 -pady 5
        }
        
        pack .ftop.menu.level2 -side left -padx 5 -pady 5 -anchor nw
        
        # MLE-040130: Cheating; this should be done in C side
        global level2list
        set level2list \
            [list \
                 "$b0Id__ .ftop.menu.level2.f0 .ftop.menu.level2.f0.b0" \
                 "$b1Id__ .ftop.menu.level2.f1 .ftop.menu.level2.f1.b1" \
                 "$b2Id__ .ftop.menu.level2.f2 .ftop.menu.level2.f2.b2" \
                 "$b3Id__ .ftop.menu.level2.f3 .ftop.menu.level2.f3.b3" ]
    }

    proc actConfigureMenuLevel0Only { } {

        pack forget \
            .ftop.menu.level0 \
            .ftop.menu.level1 \
            .ftop.menu.level2 
        pack .ftop.menu.level0 -side left -anchor nw -padx 5 -pady 5
        actUnHighlightMenuLevel 0
        actUnHighlightMenuLevel 1
        actUnHighlightMenuLevel 2
    }

    proc actConfigureMenuLevel01Only { } {

        pack forget \
            .ftop.menu.level0 \
            .ftop.menu.level1 \
            .ftop.menu.level2 
        pack .ftop.menu.level0 -side left -anchor nw -padx 5 -pady 5
        pack .ftop.menu.level1 -side left -anchor nw -padx 5 -pady 5
        actUnHighlightMenuLevel 1
        actUnHighlightMenuLevel 2
    }

    proc actConfigureMenuBtn { level__ btn__ text__ id__ arrow__ } {
        set sigNum [expr 3 + $level__]
        .ftop.menu.level$level__.f$btn__.b$btn__ configure -text $text__ \
            -command " beepOnce; post \$DISP_BTN${sigNum}_SIG $id__ "
        if {$arrow__ == 0} {
            .ftop.menu.level$level__.f$btn__.b$btn__ configure -image ""
        } elseif {$arrow__ == 1} {
            .ftop.menu.level$level__.f$btn__.b$btn__ \
                configure -image marrowfor
        } elseif {$arrow__ == 2} {
            .ftop.menu.level$level__.f$btn__.b$btn__ \
                configure -image marrowback
        }
    }

    proc actHighlightLevel0MenuBtn { btnId__ highlight__ } {
        global level0list color8 color10
        actUnHighlightMenuLevel 0
        foreach e $level0list {
            if {[lindex $e 0] == $btnId__} {
                if {$highlight__ > 0} {
                    [lindex $e 2] configure -background $color8 \
                        -activebackground $color8
                }
                if {$highlight__ == 2} {
                    [lindex $e 2] configure -image marrowfor
                } elseif {$highlight__ == 3} {
                    [lindex $e 2] configure -image marrowback
                }
            }
        }
    }

    proc actHighlightLevel1MenuBtn { btnId__ highlight__ } {
        global level1list color8
        #actUnHighlightMenuLevel 1
        foreach e $level1list {
            if {[lindex $e 0] == $btnId__} {
                if {$highlight__ > 0} {
                    [lindex $e 2] configure -background $color8 \
                        -activebackground $color8
                }
                if {$highlight__ == 2} {
                    [lindex $e 2] configure -image marrowfor
                } elseif {$highlight__ == 3} {
                    [lindex $e 2] configure -image marrowback
                }
            }
        }
    }

    proc actHighlightLevel2MenuBtn { btnId__ highlight__ } {
        global level2list color8
        #actUnHighlightMenuLevel 2
        foreach e $level2list {
            if {[lindex $e 0] == $btnId__} {
                if {$highlight__ > 0} {
                    [lindex $e 2] configure -background $color8 \
                        -activebackground $color8
                }
                if {$highlight__ == 2} {
                    [lindex $e 2] configure -image marrowfor
                } elseif {$highlight__ == 3} {
                    [lindex $e 2] configure -image marrowback
                }
            }
        }
    }

    proc actUnHighlightMenuLevel { level__ } {
        global color7
        .ftop.menu.level$level__.f0.b0 configure \
            -background $color7 -activebackground $color7 -image ""
        .ftop.menu.level$level__.f1.b1 configure \
            -background $color7 -activebackground $color7 -image ""
        .ftop.menu.level$level__.f2.b2 configure \
            -background $color7 -activebackground $color7 -image ""
        .ftop.menu.level$level__.f3.b3 configure \
            -background $color7 -activebackground $color7 -image ""
    }

    proc actConfigureSecondSlider { sliderNum } {
        pack .s$sliderNum -in .ftop.sn.sliders -side top \
            -fill both -expand yes
        raise .s$sliderNum
    }

    proc actDrawJunkTcl {} {
        # Delegate to the .cutFillDisp component
        CutFillDisp::actDrawJunkTcl
    }

    proc actDrawThis {script__} {
        # Delegate to the .cutFillDisp component
        CutFillDisp::actDrawThis $script__
    }

    proc actConfigRecordBtn {Text__ Label__} {
        # Delegate to the .cutFillDisp component
        CutFillDisp::actConfigRecordBtn $Text__ $Label__
    }

    proc actVehicleDispData { speedText__ speedBarEnd__ \
                              jobText__ modeText__ passText__ nudgeText__ \
                              manualText__ } {

        # Delegate to the .tractorDisplay component
        CutFillDisp::actVehicleDispData $speedText__ $speedBarEnd__ \
            $jobText__ $modeText__ $passText__ $nudgeText__ $manualText__
    }

    proc actShowMsg { text__ } {
        CutFillDisp::actShowMsg $text__
    }

    proc actShowAlert { text__ } {
        CutFillDisp::actShowAlert $text__
    }

    proc actToggleNudge { text__ } {
	.ftop.sn.nudges.toggle configure -text $text__
    }

    proc actConfigCpuLoadText { text__ } {
        .ftop.cpuload.l configure -text $text__
    }

    proc actConfigureBladeText { tag__ text__ } {
	.ftop.sn.elevations.bladeTag configure -text $tag__
	.ftop.sn.elevations.blade configure -text $text__
    }

    proc actConfigureGradeText { tag__ text__ } {
	.ftop.sn.elevations.gradeTag configure -text $tag__
	.ftop.sn.elevations.grade configure -text $text__
    }

    proc actConfigureNudgeText { text__ } {
	.ftop.sn.elevations.nudge configure -text $text__ 
    }

    proc actFallDataDisp { mainFallAngle__   mainFall__ sideFall__} {
        CutFillDisp::actFallDataDisp $mainFallAngle__ $mainFall__ $sideFall__
    }

    proc actBladeOffsetDisp { bladeOffset__ color__} {
        CutFillDisp::actBladeOffsetDisp $bladeOffset__ $color__
    }

    proc actNumSats { numBase__ baseColor__ numRover__ roverColor__ } {
	CutFillDisp::actNumSats $numBase__ $baseColor__ $numRover__ $roverColor__
    }

    proc actGradePointDisp { gradePointTag__ gradePoints__ } {
        CutFillDisp::actGradePointDisp $gradePointTag__ $gradePoints__
    }

    proc actGridDataDisp { northGridTag__ northGrid__   eastGridTag__ eastGrid__ } {
        CutFillDisp::actGridDataDisp $northGridTag__ $northGrid__ $eastGridTag__ $eastGrid__ 
    }
    proc actConfigGradeFloat { left__ bottom__ right__ top__ } {
        CutFillDisp::actConfigGradeFloat $left__ $bottom__ $right__ $top__
    }

    proc actSliderValue { sliderNum val notch } {
        Sliders::actSliderValue $sliderNum $val $notch
    }

    proc actDrawFallArrow { left__ bottom__ right__ top__ } {
        CutFillDisp::actDrawFallArrow $left__ $bottom__ $right__ $top__
    }

    proc actDrawHeadingArrow { left__ bottom__ right__ top__ } {
        CutFillDisp::actDrawHeadingArrow $left__ $bottom__ $right__ $top__
    }

    proc actDualFallDataDisp { mainFallAngle__   mainFall__ sideFall__} {
        CutFillDisp::actDualFallDataDisp $mainFallAngle__ $mainFall__ $sideFall__
    }

    proc actAlignedFallDataDisp { mainFallAngle__   fieldAngle__ mainFall__ } {
        CutFillDisp::actAlignedFallDataDisp $mainFallAngle__ $fieldAngle__ $mainFall__
    }

    proc actConfigureAlignedSlopeMode { mainFall__ fallAngle__ fieldAngle_ slopeMode__} {
        CutFillDisp::actConfigureAlignedSlopeMode $mainFall__ $fallAngle__ $fieldAngle_ $slopeMode__
    }

    proc actConfigureDualSlopeMode { mainFall__ sideFall__ fallAngle__ slopeMode__ } {
        CutFillDisp::actConfigureDualSlopeMode $mainFall__ $sideFall__ $fallAngle__ $slopeMode__
    }

    proc actConfigureLaserGradeMode { northTag__ northLocation__ eastTag__ eastLocation__} {
        CutFillDisp::actConfigureLaserGradeMode $northTag__ $northLocation__ $eastTag__ $eastLocation__
    }

    proc actConfigureGPSGradeMode { } {
        CutFillDisp::actConfigureGPSGradeMode 
    }

}
