##############################################################################
#
# al/src/tcl/autolevelsettings.tcl
#
# Screen to set system wide autolevel parameters
#
# 20050508 DEH Created
#
# Copyright (c) 2006 Novariant
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Space for title"

    # Input frame
    frame .ftop.input
    frame .ftop.input.l
    frame .ftop.input.r

    frame .ftop.input.l.r1
    SnazzyButton::create .ftop.input.l.r1.b btnBlueMU btnBlueMD 0.5 \
                "beepOnce; post $DISP_BTN1_SIG 0;" "Change"
    pack .ftop.input.l.r1.b -side left
    frame .ftop.input.l.r2
    SnazzyButton::create .ftop.input.l.r2.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 1;" "Change"
    pack .ftop.input.l.r2.b -side left        
    frame .ftop.input.l.r3
    SnazzyButton::create .ftop.input.l.r3.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 2;" "Change"
    pack .ftop.input.l.r3.b -side left        
    frame .ftop.input.l.r4
    SnazzyButton::create .ftop.input.l.r4.b checkboxU1 checkboxD1 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 3;" " "
    pack .ftop.input.l.r4.b -side right -anchor e       
    frame .ftop.input.l.r5
    SnazzyButton::create .ftop.input.l.r5.b checkboxU1 checkboxD1 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 4;" " "
    pack .ftop.input.l.r5.b -side right -anchor e       

    # Row 1n
    frame .ftop.input.r.r1
    label .ftop.input.r.r1.l -text "Large Nudge Factor:" -font $big_font \
                -width 16 -anchor w
    label .ftop.input.r.r1.e -text "x.xx" -font $big_font \
                -width 8 -anchor w -relief sunken -borderwidth 2
    #units
    label .ftop.input.r.r1.u -text "meters" -font $big_font \
                  -width 8 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r.r1.l -side left -pady 5
    pack .ftop.input.r.r1.e -side left -padx 10 -pady 5
    pack .ftop.input.r.r1.u -side left -padx 10 -pady 5
            
       
    # Row 2
    frame .ftop.input.r.r2
    #identifying tag
    label .ftop.input.r.r2.l -text "Small Nudge Distance:" -font $big_font \
                                                   -width 16 -anchor w
    #value holder
    label .ftop.input.r.r2.e -text "x.xxx" -font $big_font \
                  -width 8 -anchor w -relief sunken -borderwidth 2
    #units
    label .ftop.input.r.r2.u -text "meters" -font $big_font \
                  -width 8 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r.r2.l -side left -pady 5 -anchor w
    pack .ftop.input.r.r2.e -side left -padx 10 -pady 5
    pack .ftop.input.r.r2.u -side left -padx 10 -pady 5
    
    # Row 3
    frame .ftop.input.r.r3
    label .ftop.input.r.r3.l -text "Desired Satellites" -font $big_font -width 16 -anchor w
    label .ftop.input.r.r3.e -text "xx" -font $big_font \
                  -width 8 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r.r3.l -side left -pady 5 -anchor w
    pack .ftop.input.r.r3.e -side left -padx 10 -pady 5

    # Row 4
    frame .ftop.input.r.r4
    label .ftop.input.r.r4.l -text "Boundary Alarm" -font $big_font -width 16 -anchor w
    pack .ftop.input.r.r4.l -side left


    # Row 5
    frame .ftop.input.r.r5
    label .ftop.input.r.r5.l -text "Use Geoid" -font $big_font -width 16 -anchor w
    pack .ftop.input.r.r5.l -side left


    # Pack rows
    pack .ftop.input.r.r1 -side top -anchor w -fill x -pady 9
    pack .ftop.input.r.r2 -side top -anchor w -fill x -pady 9
    pack .ftop.input.r.r3 -side top -anchor w -fill x -pady 9
    pack .ftop.input.r.r4 -side top -anchor w -fill x -pady 12
    pack .ftop.input.r.r5 -side top -anchor w -fill x -pady 9

    pack .ftop.input.l.r1 -side top -anchor w -fill x
    pack .ftop.input.l.r2 -side top -anchor w -fill x
    pack .ftop.input.l.r3 -side top -anchor w -fill x
    pack .ftop.input.l.r4 -side top -anchor w -fill x
    pack .ftop.input.l.r5 -side top -anchor w -fill x
    
    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
        
    pack .ftop.input2.cancel -side left -padx 10 -pady 10

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    pack .ftop.input.l -side left -anchor n
    pack .ftop.input.r -side right -anchor n
    pack .ftop.input -side top -pady 10 -pady 5
    pack .ftop.input2 -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl largeNudgeLbl smallNudgeLbl satLbl boundaryLbl
                   changeBtn boundaryBtn geoidBtn returnBtn} {
        .ftop.title configure -text $titleLbl
        .ftop.input.r.r1.l configure -text $largeNudgeLbl
        .ftop.input.r.r2.l configure -text $smallNudgeLbl
        .ftop.input.r.r3.l configure -text $satLbl
        .ftop.input.r.r4.l configure -text $boundaryLbl
        SnazzyButton::setText .ftop.input.l.r1.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input.l.r2.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input.l.r3.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input2.cancel $returnBtn 0.5
        
        pack .ftop -fill both -expand yes
    }

    proc actSetBoundaryBtn { } {
        SnazzyButton::setImage .ftop.input.l.r4.b  checkboxD1 checkboxD1 0.5	
    }

    proc actSetGeoidBtn { } {
        SnazzyButton::setImage .ftop.input.l.r5.b checkboxD1 checkboxD1  0.5	
    }

    proc actClearBoundaryBtn { } {
        SnazzyButton::setImage .ftop.input.l.r4.b checkboxU1 checkboxD1  0.5	
    }

    proc actClearGeoidBtn { } {
        SnazzyButton::setImage .ftop.input.l.r5.b checkboxU1 checkboxD1  0.5	
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actDisplaySettings {largeNudge smallNudge desiredSats } {
        .ftop.input.r.r1.e configure -text $largeNudge
        .ftop.input.r.r2.e configure -text $smallNudge
        .ftop.input.r.r3.e configure -text $desiredSats
    }
    
    proc actDisplayLargeNudge {largeNudgeDist} {
        .ftop.input.r.r1.e configure -text $largeNudgeDist
    }

    proc actDisplaySmallNudge {smallNudgeDist} {
        .ftop.input.r.r2.e configure -text $smallNudgeDist
    }

    proc actDisplayLargeNudgeUnits {largeNudgeDist} {
        .ftop.input.r.r1.u configure -text $largeNudgeDist
    }

    proc actDisplaySmallNudgeUnits {smallNudgeDist} {
        .ftop.input.r.r2.u configure -text $smallNudgeDist
    }

    proc actDisplayDesiredSats {desiredSats} {
        .ftop.input.r.r3.e configure -text $desiredSats
    }

}
