##############################################################################
#
# vc/src/tcl/calGantry.tcl
#
# Gantry Calibration Wizard Screens
#
# 20031014 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # and uses .configDisplay, and .navDisplay components)
    frame .ftop.input
    frame .ftop.display
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes

    # Display frame - displays up to 5 lines of text
    label .ftop.display.l0 -text ""
    label .ftop.display.l1 -text "" -font $big_font
    label .ftop.display.l2 -text "" -font $big_font
    label .ftop.display.l3 -text "" -font $big_font
    label .ftop.display.l4 -text "" -font $big_font

    # Input frame 
    #   - Cancel button 
    SnazzyButton::create .ftop.input.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"
    SnazzyButton::create .ftop.input.continue btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    # Turn Wheels Hard Left Frame
    frame .ftop.input.left
    frame .ftop.input.left.c1
    SnazzyButton::create .ftop.input.left.c1.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"
    SnazzyButton::create .ftop.input.left.c1.help btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN8_SIG 8" "Help"

    frame .ftop.input.left.c2    
    canvas .ftop.input.left.c2.c -width 260 -height 200 \
                      -relief sunken -borderwidth 0 -background $color6
    .ftop.input.left.c2.c create image 0 0 -anchor nw -image gantryLeft                  

    frame .ftop.input.left.c3
    label .ftop.input.left.c3.l -text "Raw Wheel Angle" -font $big_font
    SnazzyButton::create .ftop.input.left.c3.continue btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    pack .ftop.input.left.c1.cancel -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.left.c1.help -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.left.c2.c -side bottom -padx 30 -pady 10
    pack .ftop.input.left.c3.continue -side bottom -padx 5 -pady 5 -anchor se
    pack .ftop.input.left.c3.l -side top -padx 5 -pady 5 -anchor ne
    
    pack .ftop.input.left.c1 -side left -anchor s
    pack .ftop.input.left.c2 -side left -padx 10
    pack .ftop.input.left.c3 -side bottom -fill both -expand yes -anchor s

    # Turn Wheels Hard Right Frame
    frame .ftop.input.right
    frame .ftop.input.right.c1
    SnazzyButton::create .ftop.input.right.c1.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"
    SnazzyButton::create .ftop.input.right.c1.help btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN8_SIG 8" "Help"

    frame .ftop.input.right.c2    
    canvas .ftop.input.right.c2.c -width 260 -height 200 \
                      -relief sunken -borderwidth 0 -background $color6
    .ftop.input.right.c2.c create image 0 0 -anchor nw -image gantryRight                  

    frame .ftop.input.right.c3
    label .ftop.input.right.c3.l -text "Raw Wheel Angle" -font $big_font
    SnazzyButton::create .ftop.input.right.c3.continue btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    pack .ftop.input.right.c1.cancel -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.right.c1.help -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.right.c2.c -side bottom -padx 30 -pady 10
    pack .ftop.input.right.c3.continue -side bottom -padx 5 -pady 5 -anchor se
    pack .ftop.input.right.c3.l -side top -padx 5 -pady 5 -anchor ne
    
    pack .ftop.input.right.c1 -side left -anchor s
    pack .ftop.input.right.c2 -side left -padx 10
    pack .ftop.input.right.c3 -side bottom -fill both -expand yes -anchor s

    # Wheels Center Frame
    frame .ftop.input.center
    frame .ftop.input.center.c1
    SnazzyButton::create .ftop.input.center.c1.cancel btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"
    SnazzyButton::create .ftop.input.center.c1.help btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN8_SIG 8" "Help"
    frame .ftop.input.center.c2
    
    set barWidth 400
    set barHeight 40
    canvas .ftop.input.center.c2.c -width $barWidth -height $barHeight \
                      -relief sunken -borderwidth 1 -background $color6

    .ftop.input.center.c2.c \
            create rectangle 0 0 $barWidth $barHeight -fill green \
            -outline black -tags percentbar
    .ftop.input.center.c2.c create text \
                      [expr $barWidth/2] [expr $barHeight/2] -text "0%" \
                      -font $small_font -anchor c -tags percentext

    SnazzyButton::create .ftop.input.center.c2.reset btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Reset"
    pack .ftop.input.center.c1.cancel -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.center.c1.help -side bottom -padx 5 -pady 5 -anchor sw
    pack .ftop.input.center.c2.reset -side bottom -padx 5 -pady 5 -anchor s
    pack .ftop.input.center.c2.c -side left -padx 5 -pady 10
    pack .ftop.input.center.c1 -side left -fill both -expand yes -anchor s
    pack .ftop.input.center.c2 -side right -fill both -expand yes -anchor s   

    # Joystick hard left Frame
    frame .ftop.input.joystickleft
    frame .ftop.input.joystickleft.c1
    SnazzyButton::create .ftop.input.joystickleft.c1.cancel \
                         btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"

    frame .ftop.input.joystickleft.c2    
    canvas .ftop.input.joystickleft.c2.c -width 260 -height 150 \
                      -relief sunken -borderwidth 0 -background $color6
    .ftop.input.joystickleft.c2.c create image 0 0 -anchor nw \
                      -image gantryJoystickLeft                  

    frame .ftop.input.joystickleft.c3
    SnazzyButton::create .ftop.input.joystickleft.c3.continue \
                         btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    pack .ftop.input.joystickleft.c1.cancel -side bottom -padx 5 -pady 5 \
                         -anchor sw
    pack .ftop.input.joystickleft.c2.c -side bottom -padx 30 -pady 10
    pack .ftop.input.joystickleft.c3.continue -side bottom -padx 5 -pady 5 \
                         -anchor se
    
    pack .ftop.input.joystickleft.c1 -side left -anchor s
    pack .ftop.input.joystickleft.c2 -side left -padx 10
    pack .ftop.input.joystickleft.c3 -side bottom -fill both -expand yes \
                         -anchor s

    # Joystick hard right Frame
    frame .ftop.input.joystickright
    frame .ftop.input.joystickright.c1
    SnazzyButton::create .ftop.input.joystickright.c1.cancel \
                         btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"

    frame .ftop.input.joystickright.c2    
    canvas .ftop.input.joystickright.c2.c -width 260 -height 150 \
                      -relief sunken -borderwidth 0 -background $color6
    .ftop.input.joystickright.c2.c create image 0 0 -anchor nw \
                      -image gantryJoystickRight                  

    frame .ftop.input.joystickright.c3
    SnazzyButton::create .ftop.input.joystickright.c3.continue \
                         btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    pack .ftop.input.joystickright.c1.cancel -side bottom -padx 5 -pady 5 \
                         -anchor sw
    pack .ftop.input.joystickright.c2.c -side bottom -padx 30 -pady 10
    pack .ftop.input.joystickright.c3.continue -side bottom -padx 5 -pady 5 \
                          -anchor se
    
    pack .ftop.input.joystickright.c1 -side left -anchor s
    pack .ftop.input.joystickright.c2 -side left -padx 10
    pack .ftop.input.joystickright.c3 -side bottom -fill both -expand yes \
                          -anchor s

    # Step 2 Straight Frame
    frame .ftop.input.step2straight
    frame .ftop.input.step2straight.c1
    SnazzyButton::create .ftop.input.step2straight.c1.cancel \
                         btnKhakiU btnKhakiD 0.5 \
                         "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"

    frame .ftop.input.step2straight.c2    
    canvas .ftop.input.step2straight.c2.c -width 310 -height 160 \
                      -relief sunken -borderwidth 0 -background $color6
    .ftop.input.step2straight.c2.c create image 0 0 -anchor nw \
                      -image gantryStraight                  

    frame .ftop.input.step2straight.c3
    SnazzyButton::create .ftop.input.step2straight.c3.continue \
                         btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Continue"

    pack .ftop.input.step2straight.c1.cancel -side bottom -padx 5 -pady 5 \
                         -anchor sw
    pack .ftop.input.step2straight.c2.c -side bottom -padx 30 -pady 10
    pack .ftop.input.step2straight.c3.continue -side bottom -padx 5 -pady 5 \
                          -anchor se
    
    pack .ftop.input.step2straight.c1 -side left -anchor s
    pack .ftop.input.step2straight.c2 -side left -padx 10
    pack .ftop.input.step2straight.c3 -side bottom -fill both -expand yes \
                          -anchor s

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { packProc__ } {
        eval $packProc__
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actConfigureTitle { title__ } {
        .ftop.display.l0 configure -text $title__
    }

    proc actConfigurePercentBar { percent__ } {
        set w [expr 0.01*$percent__*$Screen::barWidth]
        .ftop.input.center.c2.c coords percentbar 0 0 $w $Screen::barHeight 
        set msg [format "%3.0f%%" $percent__]
        .ftop.input.center.c2.c itemconfigure percentext -text $msg
    }

    proc actConfigureL1 { line1__ } {
        global big_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
    }

    proc actConfigureL1SP { line1__ } {
        global big_font
        .ftop.display.l1 configure -text $line1__ \
                         -font $big_font -justify left
    }

    proc actConfigureL2 { line2__ } {
        global big_font
        .ftop.display.l2 configure -text $line2__ -font $big_font
    }

    proc actConfigureCancelBtn { text__ } {
        SnazzyButton::setText .ftop.input.cancel $text__ 0.5
    }

    proc actConfigureContinueBtn { text__ } {
        SnazzyButton::setText .ftop.input.continue $text__ 0.5
    }

    proc actConfigureLeftL { text__ } {
        .ftop.input.left.c3.l configure -text $text__
    }

    proc actConfigureRightL { text__ } {
        .ftop.input.right.c3.l configure -text $text__
    }

    proc actPackL2 {} {
        pack .ftop.display.l2 -side top
    }

    proc actPackLeft { text__ } {
        .ftop.input.left.c3.l configure -text $text__
        pack .ftop.input.left -side bottom -fill both -expand yes -anchor s
    }

    proc actPackRight { text__ } {
        .ftop.input.right.c3.l configure -text $text__
        pack .ftop.input.right -side bottom -fill both -expand yes -anchor s
    }

    proc actPackJoystickLeft {} {
        pack .ftop.input.joystickleft -side bottom -fill both -expand yes \
                                      -anchor s
    }

    proc actPackJoystickRight {} {
        pack .ftop.input.joystickright -side bottom -fill both -expand yes \
                                      -anchor s
    }

    proc actPackCenter {} {
        pack .ftop.input.center -side bottom -fill both -expand yes -anchor s
    }

    proc actPackCancelBtn {} {
        pack .ftop.input.cancel -side left -padx 5 -pady 5 -anchor sw
    }

    proc actPackContinueBtn {} {
        pack .ftop.input.continue -side right -padx 5 -pady 5 -anchor se
    }

    proc actPackStep2Straight {} {
        pack .ftop.input.step2straight -side bottom -fill both -expand yes \
                                      -anchor s
    }

    proc actForgetL1 {} {
        pack forget .ftop.display.l1
    }

    proc actForgetL2 {} {
        pack forget .ftop.display.l2
    }

    proc actForgetCancelBtn {} {
        pack forget .ftop.input.cancel
    }

    proc actForgetContinueBtn {} {
        pack forget .ftop.input.continue
    }

    proc actForgetLeft {} {
        pack forget .ftop.input.left
    }

    proc actForgetRight {} {
        pack forget .ftop.input.right
    }

    proc actForgetJoystickLeft {} {
        pack forget .ftop.input.joystickleft
    }

    proc actForgetJoystickRight {} {
        pack forget .ftop.input.joystickright
    }

    proc actForgetCenter {} {
        pack forget .ftop.input.center
    }

    proc actForgetLeftL {} {
        pack forget .ftop.input.left.l
    }

    proc actForgetRightL {} {
        pack forget .ftop.input.right.l
    }

    proc actForgetLeftHelpBtn {} {
        pack forget .ftop.input.left.help
    }

    proc actForgetRightHelpBtn {} {
        pack forget .ftop.input.right.help
    }

    proc actForgetStep2Straight {} {
        pack forget .ftop.input.step2straight
    }

    proc actForgetStep2StraightCancelBtn {} {
        pack forget .ftop.input.step2straight.c1.cancel
    }
    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    proc packCalGantryStep1 {title__ line1__ continue__ cancel__} {

        global huge_font big_font

        SnazzyButton::setText .ftop.input.cancel $cancel__ 0.5
        pack .ftop.input.cancel -side left -padx 5 -pady 5 -anchor sw

        SnazzyButton::setText .ftop.input.continue $continue__ 0.5
        pack .ftop.input.continue -side right -padx 5 -pady 5 -anchor se
        
        .ftop.display.l0 configure -text $title__ -font $huge_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
        pack .ftop.display.l0 -side top -pady 5
        pack .ftop.display.l1 -side top -pady 5
    }

    proc packCalGantryStep2 {title__ line1__ continue__ cancel__} {

        global huge_font big_font
        
        .ftop.display.l0 configure -text $title__ -font $huge_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
        pack .ftop.display.l0 -side top -pady 5
        pack .ftop.display.l1 -side top -pady 5
        
        pack forget .ftop.input.cancel
        pack forget .ftop.input.continue
        pack .ftop.input.step2straight -side bottom -fill both -expand yes \
                                    -anchor s
        
    }

    proc packCalGantryStep3 {title__ line1__ continue__ cancel__} {

        global huge_font big_font

        SnazzyButton::setText .ftop.input.cancel $cancel__ 0.5
        pack .ftop.input.cancel -side left -padx 5 -pady 5 -anchor sw

        SnazzyButton::setText .ftop.input.continue $continue__ 0.5
        pack .ftop.input.continue -side right -padx 5 -pady 5 -anchor se
        
        .ftop.display.l0 configure -text $title__ -font $huge_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
        pack .ftop.display.l0 -side top -pady 5
        pack .ftop.display.l1 -side top -pady 5
    }

    proc packCalGantryLeft {title__ line1__ line2__} {

        global huge_font big_font
        
        .ftop.display.l0 configure -text $title__ -font $huge_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
        .ftop.input.left.c3.l configure -text $line2__ -font $big_font

        pack .ftop.display.l0 -side top -pady 5
        pack .ftop.display.l1 -side top -pady 5
        pack .ftop.input.left -side bottom -fill both -expand yes -anchor s
    }

    proc packCalGantryRight {title__ line1__ line2__} {

        global huge_font big_font
        
        .ftop.display.l0 configure -text $title__ -font $huge_font
        .ftop.display.l1 configure -text $line1__ -font $big_font
        pack .ftop.display.l0 -side top -pady 5
        pack .ftop.display.l1 -side top -pady 5

        .ftop.input.right.c3.l configure -text $line2__
        pack .ftop.input.right -side bottom -fill both -expand yes -anchor s
    }
}
