##############################################################################
#
# vc/src/tcl/sofia.tcl
#
# Database Modify (SOFIA) Screen
#
# 20021031 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Space for title"

    # Input frame
    frame .ftop.input

    # Row 1
    frame .ftop.input.r1
    label .ftop.input.r1.l -text "Parameter name:" \
                           -font $big_font -width 20 -anchor e
    label .ftop.input.r1.e -text "UNDEFINED" -font $big_font \
                -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r1.l -side left -pady 5
    pack .ftop.input.r1.e -side left -padx 10 -pady 5
       
    # Row 2
    frame .ftop.input.r2
    label .ftop.input.r2.l -text "Parameter index:" \
                           -font $big_font -width 20 -anchor e
    label .ftop.input.r2.e -text "0" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r2.l -side left -pady 5 -anchor w
    pack .ftop.input.r2.e -side left -padx 10 -pady 5
    
    # Row 3
    frame .ftop.input.r3
    label .ftop.input.r3.l -text "Parameter value:" \
                           -font $big_font -width 20 -anchor e
    label .ftop.input.r3.e -text "0" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r3.l -side left -pady 5 -anchor w
    pack .ftop.input.r3.e -side left -padx 10 -pady 5

    # Pack rows
    pack .ftop.input.r1 -side top -anchor w -fill x
    pack .ftop.input.r2 -side top -anchor w -fill x
    pack .ftop.input.r3 -side top -anchor w -fill x
    
    # buttons frame
    frame .ftop.input2
    button .ftop.input2.done -text "Done" -width 10 -height 6 \
            -background $color5 -activebackground $color5 \
            -command {beepOnce; post $DISP_BTN0_SIG 0; }
    button .ftop.input2.entername -text "Enter..." \
            -width 10 -height 6 \
            -background $color3 -activebackground $color3 \
            -command {beepOnce; post $DISP_BTN1_SIG 1; }
    button .ftop.input2.changevalue -text "Change Parameter Value" \
            -width 10 -height 6 \
            -background $color3 -activebackground $color3 \
            -command {beepOnce; post $DISP_BTN2_SIG 2; }
    button .ftop.input2.acceptvalue -text "Accept..." \
            -width 10 -height 6 \
            -background $colorBad -activebackground $colorBad \
            -command {beepOnce; post $DISP_BTN3_SIG 3; }
        
    pack .ftop.input2.done -side right -padx 10 -pady 10
    pack .ftop.input2.entername -side left -padx 10 -pady 10
    pack .ftop.input2.changevalue -side left -padx 10 -pady 10
    pack .ftop.input2.acceptvalue -side left -padx 10 -pady 10

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    pack .ftop.input -side top -pady 10 -pady 5
    pack .ftop.input2 -side bottom -padx 40 -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {title nameLbl indexLbl valueLbl \
                   enterBtn changeBtn acceptBtn doneBtn} {
        .ftop.title configure -text $title
        .ftop.input.r1.l configure -text $nameLbl
        .ftop.input.r2.l configure -text $indexLbl
        .ftop.input.r3.l configure -text $valueLbl
        .ftop.input2.done configure -text $doneBtn
        .ftop.input2.entername configure -text $enterBtn
        .ftop.input2.changevalue configure -text $changeBtn
        .ftop.input2.acceptvalue configure -text $acceptBtn
        
        pack .ftop -fill both -expand yes

    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actChangeParameter {name index value} {
        .ftop.input.r1.e configure -text $name
        .ftop.input.r2.e configure -text $index
        .ftop.input.r3.e configure -text $value
    }

    proc actSetState {state} {
        .ftop.input2.changevalue configure -state $state
        .ftop.input2.acceptvalue configure -state $state
    }
    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
