##############################################################################
#
# vc/src/tcl/defaultunits.tcl
#
# Screen to select default units.
#
# 20031111 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Space for title"

    # Input frame
    frame .ftop.input

    # Row 1
    frame .ftop.input.r1
    label .ftop.input.r1.l -text "Short Distances:" -font $big_font \
                -width 16 -anchor e
    label .ftop.input.r1.e -text "xx meters" -font $big_font \
                -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r1.l -side left -pady 5
    pack .ftop.input.r1.e -side left -padx 10 -pady 5
    SnazzyButton::create .ftop.input.r1.b btnBlueMU btnBlueMD 0.5 \
                "beepOnce; post $DISP_BTN1_SIG 0;" "Toggle"
    pack .ftop.input.r1.b -side right
            
       
    # Row 2
    frame .ftop.input.r2
    label .ftop.input.r2.l -text "Long Distances:" -font $big_font \
                                                   -width 16 -anchor e
    label .ftop.input.r2.e -text "xx meters" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r2.l -side left -pady 5 -anchor w
    pack .ftop.input.r2.e -side left -padx 10 -pady 5
    SnazzyButton::create .ftop.input.r2.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 1;" "Toggle"
    pack .ftop.input.r2.b -side right        
    
    # Row 3
    frame .ftop.input.r3
    label .ftop.input.r3.l -text "Areas:" -font $big_font -width 16 -anchor e
    label .ftop.input.r3.e -text "xx meters" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r3.l -side left -pady 5 -anchor w
    pack .ftop.input.r3.e -side left -padx 10 -pady 5
    SnazzyButton::create .ftop.input.r3.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 2;" "Toggle"
    pack .ftop.input.r3.b -side right        

    # Row 4
    frame .ftop.input.r4
    label .ftop.input.r4.l -text "Areas:" -font $big_font -width 16 -anchor e
    label .ftop.input.r4.e -text "xx meters" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r4.l -side left -pady 5 -anchor w
    pack .ftop.input.r4.e -side left -padx 10 -pady 5
    SnazzyButton::create .ftop.input.r4.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 3;" "Toggle"
    pack .ftop.input.r4.b -side right
    
    # Row 5
    frame .ftop.input.r5
    label .ftop.input.r5.l -text "Areas:" -font $big_font -width 16 -anchor e
    label .ftop.input.r5.e -text "xx meters" -font $big_font \
                  -width 32 -anchor w -relief sunken -borderwidth 2
    pack .ftop.input.r5.l -side left -pady 0 -anchor w
    pack .ftop.input.r5.e -side left -padx 10 -pady 5
    SnazzyButton::create .ftop.input.r5.b btnBlueMU btnBlueMD 0.5 \
                  "beepOnce; post $DISP_BTN1_SIG 4;" "Toggle"
    pack .ftop.input.r5.b -side right        

    # Pack rows
    pack .ftop.input.r1 -side top -anchor w -fill x
    pack .ftop.input.r2 -side top -anchor w -fill x
    pack .ftop.input.r3 -side top -anchor w -fill x
    pack .ftop.input.r4 -side top -anchor w -fill x
    pack .ftop.input.r5 -side top -anchor w -fill x
    
    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
    SnazzyButton::create .ftop.input2.accept btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;" "Accept"            
        
    pack .ftop.input2.cancel -side left -padx 10 -pady 10
    pack .ftop.input2.accept -side right -padx 10 -pady 10

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    pack .ftop.input -side top -pady 10 -pady 5
    pack .ftop.input2 -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl shortdisLbl longdisLbl areasLbl \
                   speedLbl smallNudgeLbl toggleBtn changeBtn \
                   returnBtn acceptBtn} {
        .ftop.title configure -text $titleLbl
        .ftop.input.r1.l configure -text $shortdisLbl
        .ftop.input.r2.l configure -text $longdisLbl
        .ftop.input.r3.l configure -text $areasLbl
        .ftop.input.r4.l configure -text $speedLbl
        .ftop.input.r5.l configure -text $smallNudgeLbl
        SnazzyButton::setText .ftop.input.r1.b $toggleBtn 0.5
        SnazzyButton::setText .ftop.input.r2.b $toggleBtn 0.5
        SnazzyButton::setText .ftop.input.r3.b $toggleBtn 0.5
        SnazzyButton::setText .ftop.input.r4.b $toggleBtn 0.5
        SnazzyButton::setText .ftop.input.r5.b $changeBtn 0.5
        SnazzyButton::setText .ftop.input2.cancel $returnBtn 0.5
        SnazzyButton::setText .ftop.input2.accept $acceptBtn 0.5
        
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actDisplayDefaultUnits {shortdis longdis areas coarseElevation fineElevation} {
        .ftop.input.r1.e configure -text $shortdis
        .ftop.input.r2.e configure -text $longdis
        .ftop.input.r3.e configure -text $areas
        .ftop.input.r4.e configure -text $coarseElevation
	.ftop.input.r5.e configure -text $fineElevation
    }
    
    proc actDisplaySmallNudge {smallNudgeDist} {
        .ftop.input.r5.e configure -text $smallNudgeDist
    }

    proc actDisplayShortDis {shortdis} {
        .ftop.input.r1.e configure -text $shortdis
    }

    proc actDisplayLongDis {longdis} {
        .ftop.input.r2.e configure -text $longdis
    }
    
    proc actDisplayAreas {areas} {
        .ftop.input.r3.e configure -text $areas
    }
    
    proc actDisplaySpeed {speed} {
        .ftop.input.r4.e configure -text $speed
    }
    
    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
