##############################################################################
#
# vc/src/tcl/examineGps.tcl
#
# Screen to display details about Position examination.
#
# 20030613 M_S - created
#
# Copyright (c) 2002-2003 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # NOTE: using place for positioning imported frames (-in option)
    #       craches Tcl interpreter. Therefore pack must be used.
    pack .navDisplay -in .ftop -side right -anchor n -padx 10 -pady 10
    raise .navDisplay

    # I/O summary
    set ioRelX 0.18 
    set ioRelY 0.12 
    label .ftop.dataLbl -text "Data" -font $medium_font
    place .ftop.dataLbl -relx $ioRelX -x 0 -rely $ioRelY -y -25 -anchor ne
    label .ftop.gmtLbl -text "GMT" -font $medium_font
    place .ftop.gmtLbl -relx $ioRelX -x 100 -rely $ioRelY -y -25 -anchor ne
    label .ftop.satsLbl -text "Sats" -font $medium_font
    place .ftop.satsLbl -relx $ioRelX -x 180 -rely $ioRelY -y -25 -anchor ne
    label .ftop.clockLbl -text "Clock" -font $medium_font
    place .ftop.clockLbl -relx $ioRelX -x 240 -rely $ioRelY -y -25 -anchor ne
    
    label .ftop.cab1Lbl -text "Cab1 L1" -font $medium_font -foreground red
    place .ftop.cab1Lbl -relx $ioRelX -x -50 -rely $ioRelY -y 0 -anchor ne
    label .ftop.cab2Lbl -text "Cab2 L1" -font $medium_font -foreground blue
    place .ftop.cab2Lbl -relx $ioRelX -x -50 -rely $ioRelY -y 25 -anchor ne
    label .ftop.cab3Lbl -text "Cab3 L1" -font $medium_font -foreground darkgreen
    place .ftop.cab3Lbl -relx $ioRelX -x -50 -rely $ioRelY -y 50 -anchor ne
    label .ftop.refLbl -text "Base L1" -font $medium_font  -foreground yellow2
    place .ftop.refLbl -relx $ioRelX -x -50 -rely $ioRelY -y 75 -anchor ne
    label .ftop.cabL2Lbl -text "Cab1 L2" -font $medium_font -foreground purple
    place .ftop.cabL2Lbl -relx $ioRelX -x -50 -rely $ioRelY -y 100 -anchor ne
    label .ftop.refL2Lbl -text "Base L2" -font $medium_font -foreground black
    place .ftop.refL2Lbl -relx $ioRelX -x -50 -rely $ioRelY -y 125 -anchor ne

    label .ftop.io11 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io11 -relx $ioRelX -x 0 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io12 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io12 -relx $ioRelX -x 120 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io13 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io13 -relx $ioRelX -x 180 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io14 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io14 -relx $ioRelX -x 240 -rely $ioRelY -y 0 -anchor ne
    label .ftop.io15 -width 10 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io15 -relx $ioRelX -x 340 -rely $ioRelY -y 0 -anchor ne


    label .ftop.io21 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io21 -relx $ioRelX -x 0 -rely $ioRelY -y 25 -anchor ne
    label .ftop.io22 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io22 -relx $ioRelX -x 120 -rely $ioRelY -y 25 -anchor ne
    label .ftop.io23 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io23 -relx $ioRelX -x 180 -rely $ioRelY -y 25 -anchor ne
#    label .ftop.io24 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
#    place .ftop.io24 -relx $ioRelX -x 240 -rely $ioRelY -y 25 -anchor ne

    label .ftop.io31 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io31 -relx $ioRelX -x 0 -rely $ioRelY -y 50 -anchor ne
    label .ftop.io32 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io32 -relx $ioRelX -x 120 -rely $ioRelY -y 50 -anchor ne
    label .ftop.io33 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io33 -relx $ioRelX -x 180 -rely $ioRelY -y 50 -anchor ne
#    label .ftop.io34 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
#    place .ftop.io34 -relx $ioRelX -x 240 -rely $ioRelY -y 50 -anchor ne

    label .ftop.io41 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io41 -relx $ioRelX -x 0 -rely $ioRelY -y 75 -anchor ne
    label .ftop.io42 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io42 -relx $ioRelX -x 120 -rely $ioRelY -y 75 -anchor ne
    label .ftop.io43 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io43 -relx $ioRelX -x 180 -rely $ioRelY -y 75 -anchor ne
    label .ftop.io44 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io44 -relx $ioRelX -x 240 -rely $ioRelY -y 75 -anchor ne
    label .ftop.io45 -width 10 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io45 -relx $ioRelX -x 340 -rely $ioRelY -y 75 -anchor ne

    label .ftop.io51 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io51 -relx $ioRelX -x 0 -rely $ioRelY -y 100 -anchor ne
    label .ftop.io52 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io52 -relx $ioRelX -x 120 -rely $ioRelY -y 100 -anchor ne
    label .ftop.io53 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io53 -relx $ioRelX -x 180 -rely $ioRelY -y 100 -anchor ne
#    label .ftop.io54 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
#    place .ftop.io54 -relx $ioRelX -x 240 -rely $ioRelY -y 100 -anchor ne

    label .ftop.io61 -width 4 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io61 -relx $ioRelX -x 0 -rely $ioRelY -y 125 -anchor ne
    label .ftop.io62 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.io62 -relx $ioRelX -x 120 -rely $ioRelY -y 125 -anchor ne
    label .ftop.io63 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
    place .ftop.io63 -relx $ioRelX -x 180 -rely $ioRelY -y 125 -anchor ne
#    label .ftop.io64 -width 5 -relief sunken -borderwidth 2 -font $medium_font 
#    place .ftop.io64 -relx $ioRelX -x 240 -rely $ioRelY -y 125 -anchor ne

    # baseline summary
    set baseRelX 0.75 
    set baseRelY 0.35 
    label .ftop.pLbl -text "P" -font $medium_font
    place .ftop.pLbl -relx $baseRelX -x 0 -rely $baseRelY -y -25 -anchor ne
    label .ftop.a1Lbl -text "A1" -font $medium_font
    place .ftop.a1Lbl -relx $baseRelX -x 60 -rely $baseRelY -y -25 -anchor ne
    label .ftop.a2Lbl -text "A2" -font $medium_font
    place .ftop.a2Lbl -relx $baseRelX -x 120 -rely $baseRelY -y -25 -anchor ne
    
    label .ftop.dopLbl -text "DOP" -font $medium_font
    place .ftop.dopLbl -relx $baseRelX -x -50 -rely $baseRelY -y 0 -anchor ne
    label .ftop.svUsedLbl -text "Sats Used" -font $medium_font
    place .ftop.svUsedLbl -relx $baseRelX -x -50 -rely $baseRelY -y 25 \
                         -anchor ne

    label .ftop.base11 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base11 -relx $baseRelX -x 20 -rely $baseRelY -y 0 -anchor ne
    label .ftop.base12 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base12 -relx $baseRelX -x 80 -rely $baseRelY -y 0 -anchor ne
    label .ftop.base13 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base13 -relx $baseRelX -x 140 -rely $baseRelY -y 0 -anchor ne
    
    label .ftop.base21 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base21 -relx $baseRelX -x 20 -rely $baseRelY -y 25 -anchor ne
    label .ftop.base22 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base22 -relx $baseRelX -x 80 -rely $baseRelY -y 25 -anchor ne
    label .ftop.base23 -width 6 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.base23 -relx $baseRelX -x 140 -rely $baseRelY -y 25 -anchor ne

    # gps position summary
    set gpsRelX 0.35 
    set gpsRelY 0.55 
    label .ftop.latLbl -text "Tractor Lat" -font $medium_font
    place .ftop.latLbl -relx $gpsRelX -x 0 -rely $gpsRelY -y -25 -anchor ne
    label .ftop.lonLbl -text "Tractor Lon" -font $medium_font
    place .ftop.lonLbl -relx $gpsRelX -x 0 -rely $gpsRelY -y 0 -anchor ne
    label .ftop.altLbl -text "Tractor Alt" -font $medium_font
    place .ftop.altLbl -relx $gpsRelX -x 0 -rely $gpsRelY -y 25 -anchor ne

    label .ftop.gps11 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.gps11 -relx $gpsRelX -x 10 -rely $gpsRelY -y -25 -anchor nw
    label .ftop.gps21 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.gps21 -relx $gpsRelX -x 10 -rely $gpsRelY -y 0 -anchor nw
    label .ftop.gps31 -width 20 -relief sunken -borderwidth 2 \
         -font $medium_font -text "00.00"
    place .ftop.gps31 -relx $gpsRelX -x 10 -rely $gpsRelY -y 25 -anchor nw

    # gps quality/accuracy summary
    set qualRelX 0.80 
    set qualRelY 0.55 
    label .ftop.qualLbl -text "Quality" -font $medium_font
    place .ftop.qualLbl -relx $qualRelX -x 0 -rely $qualRelY -y 0 -anchor ne
    label .ftop.accLbl -text "Accuracy" -font $medium_font
    place .ftop.accLbl -relx $qualRelX -x 0 -rely $qualRelY -y 25 -anchor ne

    label .ftop.qual11 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.qual11 -relx $qualRelX -x 10 -rely $qualRelY -y 0 -anchor nw
    label .ftop.qual21 -width 12 -relief sunken -borderwidth 2 \
         -font $medium_font 
    place .ftop.qual21 -relx $qualRelX -x 10 -rely $qualRelY -y 25 -anchor nw


    # buttons
    button .ftop.gpsLog \
            -height 3 -width 10 \
            -background $color3 -activebackground $color3 \
            -command {beepOnce; post $DISP_BTN1_SIG 1 }
    place .ftop.gpsLog -x 0 -rely 1.0 -y -130 -anchor sw            
    button .ftop.return \
            -height 6 -width 10 \
            -background $color5 -activebackground $color5 \
            -command {beepOnce; post $DISP_BTN9_SIG 9 }
    place .ftop.return -x 0 -rely 1.0 -y -10 -anchor sw            

    # barchart canvas
    set numbars 48
    set bar_x   528
    set track_h 125
    set maxwinx 480
    set maxwiny 125
    set bar_y   [expr $track_h-40]
    set bar_w   [expr $bar_x/$numbars]
    
    canvas .ftop.c -height $track_h -width [expr $bar_x+1] \
           -relief sunken -borderwidth 1
    place .ftop.c -x 115 -rely 1.0 -y -10 -anchor sw
           
    for {set ind 1} {$ind <= $numbars} {incr ind} {
        .ftop.c create line 0 0 0 0 -width 1 -fill yellow3 -tag sep$ind
        .ftop.c create line 0 0 0 0 -width [expr $bar_w] -fill blue -tag bar$ind
#        .ftop.c create rectangle 0 0 0 0 -tag bartwo$ind -stipple gray25 -fill red
#        .ftop.c create line 0 0 0 0 -width 5 -tag bartwob$ind -fill grey
#        .ftop.c create line 0 0 0 0 -width 5 -tag bartwo$ind -stipple gray50 -fill grey
        .ftop.c create line 0 0 0 0 -width 6 -tag bartwo$ind -fill grey
        .ftop.c create text \
              [expr ($bar_w)*($ind-1)] \
              [expr $bar_y + 15 + ($ind/2.0 -floor($ind/2.0))*0] \
              -anchor w -text " " -tag barlbl$ind -font {times 1}
        .ftop.c create text \
              [expr ($bar_w)*($ind-1)] \
              [expr $bar_y + 30] \
              -anchor w -text " " -tag elevlbl$ind -font {times 1}
    }
    .ftop.c create rectangle 1 $bar_y [expr $bar_x+2] 1 -outline black
    .ftop.c create line 1 [expr $bar_y*3.0/4.0] [expr $bar_x+2] \
                               [expr $bar_y*3.0/4.0]
    .ftop.c create line 1 [expr $bar_y/2.0] [expr $bar_x+2] [expr $bar_y/2.0]
    .ftop.c create line 1 [expr $bar_y/4.0] [expr $bar_x+2] [expr $bar_y/4.0]

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    
    proc actEntry { returnBtn gpsLogBtn accLbl qualLbl } {
        .ftop.return configure -text $returnBtn
        .ftop.gpsLog configure -text $gpsLogBtn
        .ftop.accLbl configure -text $accLbl
        .ftop.qualLbl configure -text $qualLbl
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # other action procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    proc actSetColor {ind color} {
        .ftop.c itemconfigure bar$ind -fill $color
        .ftop.c itemconfigure barlbl$ind -fill $color
    }

    proc actSetColor2 {ind color} {
        .ftop.c itemconfigure bartwo$ind -fill $color
#        .ftop.c itemconfigure bartwo$ind -fill yellow2
    }

    proc actSetLabel {ind label} {
        .ftop.c itemconfigure barlbl$ind -text $label
        .ftop.c itemconfigure barlbl$ind -font {times 10}
    }

    proc actSetElev {ind label} {
        .ftop.c itemconfigure elevlbl$ind -text $label
        .ftop.c itemconfigure elevlbl$ind -font {times 10}
    }

    proc actSetBar {ind frac} {
        global Screen::bar_w 
        global Screen::bar_y
        global Screen::numbars
        set x [expr $ind*$bar_w-4]
        .ftop.c coords bar$ind $x $bar_y \
            $x [expr $Screen::bar_y - $Screen::bar_y*$frac]
    }

    proc actSetBar2 {ind frac} {
        global Screen::bar_w 
        global Screen::bar_y
        global Screen::numbars
#        set x1 [expr $ind*$bar_w-6]
#        set x2 [expr $ind*$bar_w-2]
        set x [expr $ind*$bar_w-1]
        .ftop.c coords bartwo$ind $x $bar_y \
            $x [expr $Screen::bar_y - $Screen::bar_y*$frac]
    }

    proc actSetSep {ind} {
        global Screen::track_h
        global Screen::bar_w 
        global Screen::bar_y
        set x [expr $ind*$bar_w-9]
        .ftop.c coords sep$ind $x $track_h \
            $x [expr $Screen::bar_y - $Screen::bar_y]
    }
   
    proc actSetIoCell { i j val {col lightgrey} } {
        .ftop.io$i$j configure -text $val
        .ftop.io$i$j configure -background $col
    }

    proc actSetIoCellCol { i j col} {
        .ftop.io$i$j configure -background $col
    }
   
    proc actSetBaseCell { i j val } {
        .ftop.base$i$j configure -text $val
    }

    proc actSetGpsCell { i j val } {
        .ftop.gps$i$j configure -text $val
    }
    
    proc actSetAlt { val } {
        .ftop.gps31 configure -text $val
    }

    proc actSetQualCell { i j val {col lightgrey}} {
        .ftop.qual$i$j configure -text $val
        .ftop.qual$i$j configure -background $col
    }
}
