##############################################################################
#
# vc/src/tcl/hardcore.tcl
#
# Hardcore controller-tuning screen
#
# 20021101 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it in sExit
    frame .ftop

    # Title
    frame .ftop.title
    label .ftop.title.l -text "Hardcore Controller Tuning" -font $huge_font
    frame .ftop.title.help
    button .ftop.title.help.b -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 0 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3
    pack .ftop.title.help -side right
    pack .ftop.title.l -side top
    pack .ftop.title -side top

    # This screen is divided into two halves - left and right
    frame .ftop.l
    frame .ftop.r

    # Adjustable Parameters Subframe
    frame .ftop.l.params 
    label .ftop.l.params.title -text "Adjustable Parameters:" -font $big_font

    frame .ftop.l.params.row1
    label .ftop.l.params.row1.l -text "Control Gain:" -font $medium_font
    label .ftop.l.params.row1.e -text "0" -anchor w\
          -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row1.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 0 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row1.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 1 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    frame .ftop.l.params.row2
    label .ftop.l.params.row2.l -text "Integral Rate:" -font $medium_font
    label .ftop.l.params.row2.e -anchor w\
            -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row2.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 1 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row2.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 2 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    frame .ftop.l.params.row3
    label .ftop.l.params.row3.l -text "Heading Gain Fac.:" -font $medium_font
    label .ftop.l.params.row3.e -anchor w\
            -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row3.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 2 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row3.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 3 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    frame .ftop.l.params.row4
    label .ftop.l.params.row4.l -text "Max. Delta Heading:" -font $medium_font
    label .ftop.l.params.row4.e -anchor w\
            -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row4.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 3 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row4.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 4 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    frame .ftop.l.params.row5
    label .ftop.l.params.row5.l -text "Max. Delta Heading:" -font $medium_font
    label .ftop.l.params.row5.e -anchor w\
            -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row5.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 4 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row5.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 5 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    frame .ftop.l.params.row6
    label .ftop.l.params.row6.l -text "Max. Delta Heading:" -font $medium_font
    label .ftop.l.params.row6.e -anchor w\
            -font $medium_font -width 8 -relief sunken -borderwidth 2
    button .ftop.l.params.row6.change -text "Change" \
            -command { beepOnce; post $DISP_BTN1_SIG 5 } \
            -width 5 -height 1 \
            -background $color3 -activebackground $color3
    button .ftop.l.params.row6.help -text "?" \
            -command { beepOnce; post $DISP_BTN8_SIG 6 } \
            -width 1 -height 1 \
            -background $color3 -activebackground $color3

    # Step-Response Subframe
    frame .ftop.l.step
    label .ftop.l.step.title -text "Constant Heading \[degrees\]:" \
            -font $big_font

    button .ftop.l.step.zero -text "0" \
         -command { beepOnce; post $DISP_BTN2_SIG 0 } \
         -width 3 -height 3 \
         -background $color3 -activebackground $color3

    frame .ftop.l.step.neg
    button .ftop.l.step.neg.b1 -text "5L" \
         -command { beepOnce; post $DISP_BTN2_SIG 1 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3
    button .ftop.l.step.neg.b2 -text "15L" \
         -command { beepOnce; post $DISP_BTN2_SIG 2 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3
    button .ftop.l.step.neg.b3 -text "30L" \
         -command { beepOnce; post $DISP_BTN2_SIG 3 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3

    frame .ftop.l.step.pos
    button .ftop.l.step.pos.b1 -text "5R" \
         -command { beepOnce; post $DISP_BTN2_SIG 4 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3
    button .ftop.l.step.pos.b2 -text "15R" \
         -command { beepOnce; post $DISP_BTN2_SIG 5 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3
    button .ftop.l.step.pos.b3 -text "30R" \
         -command { beepOnce; post $DISP_BTN2_SIG 6 } \
         -width 3 -height 1 \
         -background $color3 -activebackground $color3

    # .cpf controls subframe
    frame .ftop.l.cpf
    frame .ftop.l.cpf.r1 
    frame .ftop.l.cpf.r2 
    frame .ftop.l.cpf.r3 
    button .ftop.l.cpf.r1.parse -text "Parse" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 0 } \
            -width 8 -height 1
    button .ftop.l.cpf.r1.activate -text "Activate" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 1 } \
            -width 8 -height 1
    button .ftop.l.cpf.r1.reinit -text "Re-Init" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 2 } \
            -width 8 -height 1
    button .ftop.l.cpf.r2.confA -text "Config A" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 8 } \
            -width 8 -height 1
    button .ftop.l.cpf.r2.confB -text "Config B" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 9 } \
            -width 8 -height 1
    button .ftop.l.cpf.r2.confC -text "Config C" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 10 } \
            -width 8 -height 1
    button .ftop.l.cpf.r3.savedata -text "Save\nData: Off" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 5 } \
            -width 8 -height 2
    button .ftop.l.cpf.r3.exportdata -text "Export\nData: Off" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 7 } \
            -width 8 -height 2
    button .ftop.l.cpf.r3.toggle -text "Toggle\nSlider" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 6 } \
            -width 8 -height 2

    # small .cpf controls subframe
    frame .ftop.l.scpf
    button .ftop.l.scpf.confA -text "A" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 8 } \
            -width 3 -height 1
    button .ftop.l.scpf.confB -text "B" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 9 } \
            -width 3 -height 1
    button .ftop.l.scpf.confC -text "C" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 10 } \
            -width 3 -height 1
    button .ftop.l.scpf.exportdata -text "Exp.: Off" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN3_SIG 7 } \
            -width 6 -height 1

    # Response-Rate Slider Subframe
    frame .ftop.l.slider

    # Openloop controls subframe
    frame .ftop.l.olcontrols
    button .ftop.l.olcontrols.bigLeft -text "<<" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN4_SIG 0 } \
            -width 3 -height 2
    button .ftop.l.olcontrols.smallLeft -text "<" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN4_SIG 1 } \
            -width 3 -height 2
    button .ftop.l.olcontrols.zero -text "0" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN4_SIG 2 } \
            -width 3 -height 2
    button .ftop.l.olcontrols.smallRight -text ">" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN4_SIG 3 } \
            -width 3 -height 2
    button .ftop.l.olcontrols.bigRight -text ">>" \
            -background $color3 -activebackground $color3 \
            -command { beepOnce; post $DISP_BTN4_SIG 4 } \
            -width 3 -height 2
    pack .ftop.l.olcontrols.bigLeft -side left -padx 5 -expand yes
    pack .ftop.l.olcontrols.smallLeft -side left -padx 5 -expand yes
    pack .ftop.l.olcontrols.zero -side left -padx 5 -expand yes
    pack .ftop.l.olcontrols.smallRight -side left -padx 5 -expand yes
    pack .ftop.l.olcontrols.bigRight -side left -padx 5 -expand yes
 
    # Try Autosteer or Line-Acquisition  Subframe
    frame .ftop.l.autosteer
    label .ftop.l.autosteer.title -text "Try AutoSteering:" -font $big_font

    button .ftop.l.autosteer.stop -image smallSTOP \
            -command { beepOnce; post $DISP_BTN0_SIG 0 "stop autosteer" } \
            -width 80 -height 80 \
            -background $color6 -activebackground $color6 \
            -foreground red -activeforeground red \
            -borderwidth 0
    button .ftop.l.autosteer.go -image smallGO \
            -command { beepOnce; post $DISP_BTN0_SIG 1 "go autosteer" } \
            -width 80 -height 80 \
            -background $color6 -activebackground $color6 \
            -foreground green -activeforeground green \
            -borderwidth 0
    
    button .ftop.l.autosteer.pusher -text "Pusher\nBar\nDown" \
            -command Screen::NotYetImplemented -width 8 -height 3 \
            -background orange -activebackground orange

    # Accept/Reject Subframe
    frame .ftop.l.acceptReject
    button .ftop.l.acceptReject.b0 \
            -text "Done or Cancel" \
            -command { beepOnce; post $DISP_BTN9_SIG 9 } \
            -width 9 -height 3 \
            -background $color5 -activebackground $color5

    button .ftop.l.acceptReject.b1 \
            -text "Export .cpf\nto\n/data/currdir" \
            -command { beepOnce; post $DISP_BTN3_SIG 3 } \
            -width 9 -height 3 \
            -background $color5 -activebackground $color5

    button .ftop.l.acceptReject.b2 \
            -text "Import .cpf\nfrom\n/data/currdir or Accept\nParameters" \
            -command { beepOnce; post $DISP_BTN3_SIG 4 } \
            -width 9 -height 3 \
            -background $color0 -activebackground $color0

    # Pack the right side
    pack .tractorDisplay -in .ftop.r -side bottom -fill both -expand yes
    raise .tractorDisplay
    pack .contDataDisplay -in .ftop.r -side right -fill both -expand true
    raise .contDataDisplay

    # Pack the various elements
    pack .ftop.l -side left -fill both -expand yes
    pack .ftop.r -side right -fill both -expand yes

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { packProc__ } {
        eval $packProc__

        pack .ftop -fill both -expand yes
    }
    
    # Action called by GuiMgr on exit from this screen
    proc actExit {} {

        destroy .ftop

    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    # Update procedures of this template can be called by the GuiMgr
    proc actUnHighlightStepButtons { } {
        global color3 colorGood
        .ftop.l.step.zero configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.neg.b1 configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.neg.b2 configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.neg.b3 configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.pos.b1 configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.pos.b2 configure -background $color3 \
                                    -activebackground $color3
        .ftop.l.step.pos.b3 configure -background $color3 \
                                    -activebackground $color3
    }

    proc actHighlightStepButton {thisButton} {
        # {MLE-030218: C side knows a little too much here in passing in 
        # .ftop.l.step.pos.b3 etc., maybe can clean up later. }
        global color3 colorGood
        $thisButton configure -background $colorGood \
                                    -activebackground $colorGood
    }

    proc actSetSteeringParameters { D10_K__ } {
        .ftop.l.params.row1.e configure -text $D10_K__
    }

    proc actSetHeadingParameters { D20_K__ } {
        .ftop.l.params.row1.e configure -text $D20_K__
    }

    proc actSetLateralErrorParameters { D30_K__ D31_A__ } {
        .ftop.l.params.row1.e configure -text $D30_K__
        .ftop.l.params.row2.e configure -text $D31_A__
     }

    proc actSetLineAcquisitionParameters { D20_K_TRAJ_FAC__ TRAJ_HE_DMAX__ \
            TRAJ_K_MAX__ TRAJ_X_F_P__A_FWD__ TRAJ_X_F_P__A_F_C__ \
            TRAJ_K_MAX_CLOSE__ \
        } {
        .ftop.l.params.row1.e configure -text $D20_K_TRAJ_FAC__
        .ftop.l.params.row2.e configure -text $TRAJ_HE_DMAX__
        .ftop.l.params.row3.e configure -text $TRAJ_K_MAX__
        .ftop.l.params.row4.e configure -text $TRAJ_X_F_P__A_FWD__
        .ftop.l.params.row5.e configure -text $TRAJ_X_F_P__A_F_C__
        .ftop.l.params.row6.e configure -text $TRAJ_K_MAX_CLOSE__
    }

    proc actConfigureSlider { } {
        # Repack the Input Frame
        pack forget .ftop.l.cpf .ftop.l.slider .ftop.l.olcontrols \
            .ftop.l.autosteer .ftop.l.acceptReject
        pack .ftop.l.cpf -side top -expand yes -fill both
        pack .ftop.l.slider -side top -expand yes -fill both
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes
    }

    proc actConfigureOlcontrols { sliderNumOld__ } {
        # Repack the Input Frame
        pack forget .s$sliderNumOld__
        pack forget .ftop.l.cpf .ftop.l.slider .ftop.l.olcontrols \
            .ftop.l.autosteer .ftop.l.acceptReject
        pack .ftop.l.cpf -side top -expand yes -fill both
        pack .ftop.l.olcontrols -side top -expand yes -fill both
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes
    }

    proc actToggleSlider { sliderNumOld__ sliderNumNew__ } {
        pack forget .s$sliderNumOld__
        pack .s$sliderNumNew__ -in .ftop.l.slider -side top -pady 10
        raise .s$sliderNumNew__
    }

    proc actConfigureRowlineup { manualSteeringText__ } {

        pack forget .ftop.l.autosteer.stop
        pack .ftop.l.autosteer.go -side top
        TractorDisplay::actConfigureRowlineup $manualSteeringText__

    }

    proc actConfigureAutosteer { } {

        pack forget .ftop.l.autosteer.go
        pack .ftop.l.autosteer.stop -side top
        TractorDisplay::actConfigureAutosteer

    }

    proc actConfigTractorIcon { tractorType__ tractorColor__ \
            implWidth__ implOffset__} {
        # Delegate to the .tractorDisplay component
        TractorDisplay::actConfigTractorIcon \
                $tractorType__ $tractorColor__ $implWidth__ $implOffset__
    }

    proc actVehicleDispData { velDispText__ Vx__ VxMax__ headingError__ posError__ \
            passWidth__ fanAngle__ rowNumText__ nudgeDistText__ \
            turboMessageText__ ENHANCED_RLM__ \
            ERLM_HE_ENTER__ ERLM_HE_EXIT__ \
            ERLM_YC_ENTER__ ERLM_YC_EXIT__ \
            inTightMode__} {

        # Delegate to the .tractorDisplay component
        TractorDisplay::actVehicleDispData $velDispText__ $Vx__ $VxMax__ \
                $headingError__ $posError__ $passWidth__ $fanAngle__ \
                $rowNumText__ $nudgeDistText__ \
                $turboMessageText__ $ENHANCED_RLM__ $ERLM_HE_ENTER__ \
                $ERLM_HE_EXIT__ $ERLM_YC_ENTER__ $ERLM_YC_EXIT__ \
                $inTightMode__
    }

    proc actSteerCodeDisp { turningWheelText__ killText__ clutchText__ \
            parkText__ resetReqText__ roadingText__ comsBadText__ \
            notReadyText__ inxUnsText__ } {

        # Delegate to the .tractorDisplay component
        TractorDisplay::actSteerCodeDisp $turningWheelText__ $killText__ \
                $clutchText__ $parkText__ $resetReqText__ $roadingText__ \
                $comsBadText__ $notReadyText__ $inxUnsText__
    }

    proc actToggleSaveData { text__ } {

        .ftop.l.cpf.r3.savedata configure -text "Save\nData: $text__"

    }

    proc actToggleExportData { text__ } {

        .ftop.l.cpf.r3.exportdata configure -text "Export\nData: $text__"
        .ftop.l.scpf.exportdata configure -text "Exp.: $text__"

    }

    proc actSliderValue { sliderNum val notch } {
        Sliders::sliderSetValue .s$sliderNum $val $notch
    }
    
    proc actPlotContData { } {
        ContDataDisplay::actPlotContData
    }

    proc actConfigureContDataMsg { msg__ } {
        ContDataDisplay::actConfigureContDataMsg $msg__
    }
    
    proc actPackD27 {} {
        .ftop.l.params.row2.l configure -text "D27_K1:"
        .ftop.l.params.row2.change configure -text "Change"
        pack .ftop.l.params.row2.l -side left
        pack .ftop.l.params.row2.change -side right
        pack .ftop.l.params.row2.e -side right
        pack .ftop.l.params.row2 -side top -fill x -expand yes -pady 5

        .ftop.l.params.row3.l configure -text "D27_K1:"
        .ftop.l.params.row3.change configure -text "Change"
        pack .ftop.l.params.row3.l -side left
        pack .ftop.l.params.row3.change -side right
        pack .ftop.l.params.row3.e -side right
        pack .ftop.l.params.row3 -side top -fill x -expand yes -pady 5
    }

    proc actSetD27Parameters { D27_K1__ D27_K2__ } {
        .ftop.l.params.row2.e configure -text $D27_K1__
        .ftop.l.params.row3.e configure -text $D27_K2__
     }

    proc actPackSmallCpf {} {
        global color3
        .ftop.l.scpf.confA \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confC \
                configure -background $color3 -activebackground $color3
        pack .ftop.l.scpf.confA -side left -padx 5 -expand yes
        pack .ftop.l.scpf.confB -side left -padx 5 -expand yes
        pack .ftop.l.scpf.confC -side left -padx 5 -expand yes
        pack .ftop.l.scpf.exportdata -side left -padx 5 -expand yes
    }

    proc actConfigA {} {
        global color3
        .ftop.l.scpf.confA \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.scpf.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confC \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confA \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.cpf.r2.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confC \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.parse \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.activate \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.reinit \
                configure -background $color3 -activebackground $color3
    }    

    proc actConfigB {} {
        global color3
        .ftop.l.scpf.confA \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confB \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.scpf.confC \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confA \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confB \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.cpf.r2.confC \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.parse \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.activate \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.reinit \
                configure -background $color3 -activebackground $color3
    }    

    proc actConfigC {} {
        global color3
        .ftop.l.scpf.confA \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.scpf.confC \
                configure -background $color3 -activebackground SteelBlue4
        .ftop.l.cpf.r2.confA \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confC \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.cpf.r1.parse \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.activate \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.reinit \
                configure -background $color3 -activebackground $color3
    }    

    proc actParse {} {
        global color3
        .ftop.l.cpf.r1.parse \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.cpf.r1.activate \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r1.reinit \
                configure -background $color3 -activebackground $color3
    }

    proc actActivate {} {
        global color3
        .ftop.l.cpf.r1.activate \
                configure -background SteelBlue4 -activebackground SteelBlue4
        .ftop.l.cpf.r1.reinit \
                configure -background $color3 -activebackground $color3
    }

    proc actReinit {} {
        global color3
        .ftop.l.cpf.r1.reinit \
                configure -background SteelBlue4 -activebackground SteelBlue4
    }

    proc actUnHighlightOlcontrolsButtons { } {
        global color3
        .ftop.l.olcontrols.bigLeft configure -background $color3 \
            -activebackground $color3
        .ftop.l.olcontrols.smallLeft configure -background $color3 \
            -activebackground $color3
        .ftop.l.olcontrols.zero configure -background $color3 \
            -activebackground $color3
        .ftop.l.olcontrols.smallRight configure -background $color3 \
            -activebackground $color3
        .ftop.l.olcontrols.bigRight configure -background $color3 \
            -activebackground $color3
    }

    proc actHighlightOlcontrolsButton {thisButton val} {
        # {MLE-030218: C side knows a little too much here in passing in 
        # .ftop.l.olcontrols.zero etc., maybe can clean up later. }
        global color3 colorGood
        .ftop.l.olcontrols.zero configure -text $val
        $thisButton configure \
            -background $colorGood \
            -activebackground $colorGood
    }

    #-------------------------------------------------------------------------
    # Local procedures
    #-------------------------------------------------------------------------
    proc packSteering {steeringLbl adjustLbl ctlLbl changeBtn constantLbl \
                   tryLbl cancelBtn acceptBtn} {
        .ftop.title.l configure -text $steeringLbl
        .ftop.l.params.title configure -text $adjustLbl
        .ftop.l.params.row1.l configure -text $ctlLbl
        .ftop.l.params.row1.change configure -text $changeBtn
        .ftop.l.step.title configure -text $constantLbl

        .ftop.l.step.neg.b1 configure -text "40L"
        .ftop.l.step.neg.b2 configure -text "20L"
        .ftop.l.step.neg.b3 configure -text "13L"
        .ftop.l.step.pos.b1 configure -text "40R"
        .ftop.l.step.pos.b2 configure -text "20R"
        .ftop.l.step.pos.b3 configure -text "13R"

        .ftop.l.autosteer.title configure -text $tryLbl
        .ftop.l.acceptReject.b0 configure -text $cancelBtn
        .ftop.l.acceptReject.b2 configure -text $acceptBtn

        # Adjustable Parameters Subframe
        pack .ftop.l.params.title -side top -anchor w
        pack .ftop.l.params.row1.l -side left
        pack .ftop.l.params.row1.change -side right
        pack .ftop.l.params.row1.e -side right
        pack .ftop.l.params.row1 -side top -fill x -expand yes -pady 5

        # Step-Response Subframe
        pack .ftop.l.step.title -side top -anchor w
        pack .ftop.l.step.zero -side left -pady 3 -padx 5 -expand yes
        pack .ftop.l.step.neg.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b3 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b3 -side left -pady 5 -padx 5 -expand yes
 
        pack .ftop.l.step.neg -side top
        pack .ftop.l.step.pos -side bottom

        # Line-Acquisition Subframe
        pack .ftop.l.autosteer.title -side top -anchor w
        pack .ftop.l.autosteer.go -side top

        # Accept/Reject Subframe
        pack .ftop.l.acceptReject.b0 -side left -anchor s -padx 10 -pady 5
        pack .ftop.l.acceptReject.b2 -side right -anchor s -padx 10 -pady 5

        # Pack the Input Frame
        pack .ftop.l.params -side top -expand yes 
        pack .ftop.l.step -side top -expand yes
        pack .ftop.l.scpf -side top -expand yes
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes
    }

    proc packHeading {headingLbl adjustLbl ctlLbl changeBtn constantLbl \
                   tryLbl cancelBtn acceptBtn} {
        .ftop.title.l configure -text $headingLbl
        .ftop.l.params.title configure -text $adjustLbl
        .ftop.l.params.row1.l configure -text $ctlLbl
        .ftop.l.params.row1.change configure -text $changeBtn
        .ftop.l.step.title configure -text $constantLbl
        .ftop.l.step.neg.b1 configure -text "5L"
        .ftop.l.step.neg.b2 configure -text "15L"
        .ftop.l.step.neg.b3 configure -text "30L"
        .ftop.l.step.pos.b1 configure -text "5R"
        .ftop.l.step.pos.b2 configure -text "15R"
        .ftop.l.step.pos.b3 configure -text "30R"
        .ftop.l.autosteer.title configure -text $tryLbl
        .ftop.l.acceptReject.b0 configure -text $cancelBtn
        .ftop.l.acceptReject.b2 configure -text $acceptBtn
        
        # Adjustable Parameters Subframe
        pack .ftop.l.params.title -side top -anchor w
        pack .ftop.l.params.row1.l -side left
        pack .ftop.l.params.row1.change -side right
        pack .ftop.l.params.row1.e -side right
        pack .ftop.l.params.row1 -side top -fill x -expand yes -pady 5

        # Step-Response Subframe
        pack .ftop.l.step.title -side top -anchor w
        pack .ftop.l.step.zero -side left -pady 3 -padx 5 -expand yes
        pack .ftop.l.step.neg.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b3 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b3 -side left -pady 5 -padx 5 -expand yes
 
        pack .ftop.l.step.neg -side top
        pack .ftop.l.step.pos -side bottom

        # Line-Acquisition Subframe
        pack .ftop.l.autosteer.title -side top -anchor w
        pack .ftop.l.autosteer.go -side top

        # Accept/Reject Subframe
        pack .ftop.l.acceptReject.b0 -side left -anchor s -padx 10 -pady 5
        pack .ftop.l.acceptReject.b2 -side right -anchor s -padx 10 -pady 5

        # Pack the Input Frame
        pack .ftop.l.params -side top -expand yes 
        pack .ftop.l.step -side top -expand yes
        pack .ftop.l.scpf -side top -expand yes
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes

    }

    proc packLateralError {lateralLbl adjustLbl ctlLbl rateLbl changeBtn \
                           constantLbl tryLbl cancelBtn acceptBtn} {
        .ftop.title.l configure -text $lateralLbl
        .ftop.l.params.title configure -text $adjustLbl
        .ftop.l.params.row1.l configure -text $ctlLbl
        .ftop.l.params.row2.l configure -text $rateLbl
        .ftop.l.params.row1.change configure -text $changeBtn
        .ftop.l.params.row2.change configure -text $changeBtn
        .ftop.l.step.title configure -text $constantLbl
        .ftop.l.step.neg.b1 configure -text ".1L"
        .ftop.l.step.neg.b2 configure -text ".25L"
        .ftop.l.step.neg.b3 configure -text ".5L"
        .ftop.l.step.pos.b1 configure -text ".1R"
        .ftop.l.step.pos.b2 configure -text ".25R"
        .ftop.l.step.pos.b3 configure -text ".5R"
        .ftop.l.autosteer.title configure -text $tryLbl
        .ftop.l.acceptReject.b0 configure -text $cancelBtn
        .ftop.l.acceptReject.b2 configure -text $acceptBtn

        # Adjustable Parameters Subframe
        pack .ftop.l.params.title -side top -anchor w
        pack .ftop.l.params.row1.l -side left
        pack .ftop.l.params.row1.change -side right
        pack .ftop.l.params.row1.e -side right
 
        pack .ftop.l.params.row2.l -side left
        pack .ftop.l.params.row2.change -side right
        pack .ftop.l.params.row2.e -side right

        pack .ftop.l.params.row1 -side top -fill x -expand yes -pady 5
        pack .ftop.l.params.row2 -side top -fill x -expand yes -pady 5

        # Step-Response Subframe
        pack .ftop.l.step.title -side top -anchor w
        pack .ftop.l.step.zero -side left -pady 3 -padx 5 -expand yes
        pack .ftop.l.step.neg.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.neg.b3 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b1 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b2 -side left -pady 5 -padx 5 -expand yes
        pack .ftop.l.step.pos.b3 -side left -pady 5 -padx 5 -expand yes
 
        pack .ftop.l.step.neg -side top
        pack .ftop.l.step.pos -side bottom

        # Line-Acquisition Subframe
        pack .ftop.l.autosteer.title -side top -anchor w
        pack .ftop.l.autosteer.go -side top

        # Accept/Reject Subframe
        pack .ftop.l.acceptReject.b0 -side left -anchor s -padx 10 -pady 5
        pack .ftop.l.acceptReject.b2 -side right -anchor s -padx 10 -pady 5

        # Pack the Input Frame
        pack .ftop.l.params -side top -expand yes 
        pack .ftop.l.step -side top -expand yes
        pack .ftop.l.scpf -side top -expand yes
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes
    }

    proc packLineAcquisition {lineLbl adjustLbl \
            headingainLbl maxdeltaLbl maxcurLbl tpdLbl tpcdLbl mincurLbl \
            changeBtn tryLbl cancelBtn acceptBtn} {

        .ftop.title.l configure -text $lineLbl
        .ftop.l.params.title configure -text $adjustLbl

        .ftop.l.params.row1.l configure -text $headingainLbl
        .ftop.l.params.row2.l configure -text $maxdeltaLbl
        .ftop.l.params.row3.l configure -text $maxcurLbl
        .ftop.l.params.row4.l configure -text $tpdLbl
        .ftop.l.params.row5.l configure -text $tpcdLbl
        .ftop.l.params.row6.l configure -text $mincurLbl

        .ftop.l.params.row1.change configure -text $changeBtn
        .ftop.l.params.row2.change configure -text $changeBtn
        .ftop.l.params.row3.change configure -text $changeBtn
        .ftop.l.params.row4.change configure -text $changeBtn
        .ftop.l.params.row5.change configure -text $changeBtn
        .ftop.l.params.row6.change configure -text $changeBtn

        .ftop.l.autosteer.title configure -text $tryLbl
        .ftop.l.acceptReject.b0 configure -text $cancelBtn
        .ftop.l.acceptReject.b2 configure -text $acceptBtn

        # Adjustable Parameters Subframe
        pack .ftop.l.params.title -side top -anchor w
        pack .ftop.title.help.b -side top

        pack .ftop.l.params.row1.l -side left
        pack .ftop.l.params.row1.help -side right
        pack .ftop.l.params.row1.change -side right
        pack .ftop.l.params.row1.e -side right

        pack .ftop.l.params.row2.l -side left
        pack .ftop.l.params.row2.help -side right
        pack .ftop.l.params.row2.change -side right
        pack .ftop.l.params.row2.e -side right

        pack .ftop.l.params.row3.l -side left
        pack .ftop.l.params.row3.help -side right
        pack .ftop.l.params.row3.change -side right
        pack .ftop.l.params.row3.e -side right

        pack .ftop.l.params.row4.l -side left
        pack .ftop.l.params.row4.help -side right
        pack .ftop.l.params.row4.change -side right
        pack .ftop.l.params.row4.e -side right

        pack .ftop.l.params.row5.l -side left
        pack .ftop.l.params.row5.help -side right
        pack .ftop.l.params.row5.change -side right
        pack .ftop.l.params.row5.e -side right

        pack .ftop.l.params.row6.l -side left
        pack .ftop.l.params.row6.help -side right
        pack .ftop.l.params.row6.change -side right
        pack .ftop.l.params.row6.e -side right

        pack .ftop.l.params.row1 -side top -fill x -expand yes -pady 3
        pack .ftop.l.params.row2 -side top -fill x -expand yes -pady 3
        pack .ftop.l.params.row3 -side top -fill x -expand yes -pady 3
        pack .ftop.l.params.row4 -side top -fill x -expand yes -pady 3
        pack .ftop.l.params.row5 -side top -fill x -expand yes -pady 3
        pack .ftop.l.params.row6 -side top -fill x -expand yes -pady 3

        # Line-Acquisition Subframe
        pack .ftop.l.autosteer.title -side top -anchor w
        pack .ftop.l.autosteer.go -side top

        # Accept/Reject Subframe
        pack .ftop.l.acceptReject.b0 -side left -anchor s -padx 10 -pady 5
        pack .ftop.l.acceptReject.b2 -side right -anchor s -padx 10 -pady 5

        # Pack the Input Frame
        pack .ftop.l.params -side top -expand yes
        pack .ftop.l.scpf -side top -expand yes
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes

    }

    proc packHardcore {hardcoreLbl parseBtn activateBtn reinitBtn saveBtn \
            exportBtn toggleBtn tryLbl doneBtn getBtn acceptBtn} {
        global color3
        .ftop.title.l configure -text $hardcoreLbl
        .ftop.l.cpf.r1.parse configure -text $parseBtn
        .ftop.l.cpf.r1.activate configure -text $activateBtn
        .ftop.l.cpf.r1.reinit configure -text $reinitBtn
        .ftop.l.cpf.r3.savedata configure -text $saveBtn
        .ftop.l.cpf.r3.exportdata configure -text $exportBtn
        .ftop.l.cpf.r3.toggle configure -text $toggleBtn
        .ftop.l.autosteer.title configure -text $tryLbl
        .ftop.l.acceptReject.b0 configure -text $doneBtn
        .ftop.l.acceptReject.b1 configure -text $getBtn
        .ftop.l.acceptReject.b2 configure -text $acceptBtn

        .ftop.l.cpf.r2.confA \
                configure -background $color3  -activebackground $color3
        .ftop.l.cpf.r2.confB \
                configure -background $color3 -activebackground $color3
        .ftop.l.cpf.r2.confC \
                configure -background $color3 -activebackground $color3

        # .cpf controls subframe
        pack .ftop.l.cpf.r1.parse -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r1.activate -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r1.reinit -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r2.confA -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r2.confB -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r2.confC -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r3.savedata -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r3.exportdata -side left -padx 5 -expand yes
        pack .ftop.l.cpf.r3.toggle -side left -padx 5 -expand yes

        pack .ftop.l.cpf.r2 -side top -expand yes -fill both -pady 5
        pack .ftop.l.cpf.r1 -side top -expand yes -fill both -pady 5
        pack .ftop.l.cpf.r3 -side top -expand yes -fill both -pady 5

        # Response-Rate Slider Subframe
        pack .s0 -in .ftop.l.slider -side top
        raise .s0

        # Try Autosteer Subframe
        pack .ftop.l.autosteer.title -side top -anchor w

        # Accept/Reject Subframe
        pack .ftop.l.acceptReject.b0 -side left -padx 5 -pady 3 -expand yes
        pack .ftop.l.acceptReject.b1 -side left -padx 5 -pady 3 -expand yes
        pack .ftop.l.acceptReject.b2 -side left -padx 5 -pady 3 -expand yes

        # Pack the Input Frame
        pack .ftop.l.cpf -side top -expand yes -fill both
        pack .ftop.l.slider -side top -expand yes -fill both
        pack .ftop.l.autosteer -side top -expand yes
        pack .ftop.l.acceptReject -side top -expand yes

    }
}









