##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Modal { 

    #-------------------------------------------------------------------------
    # Define and pack the helpscreen
    #-------------------------------------------------------------------------
    # Top level frame
    frame .fmodal

    # helpscreen frame
    frame .fmodal.helpscreen

    # display frame
    frame .fmodal.helpscreen.display

    # Pack helpscreen
    pack .fmodal.helpscreen.display -side top -padx 5 -pady 5 \
            -fill both -expand yes
    pack .fmodal.helpscreen -side bottom -fill both -expand yes -anchor s

    #-------------------------------------------------------------------------
    # Entry and exit procedures
    #-------------------------------------------------------------------------
    proc actEntry { helpFilename__ } {
        pack forget .ftop

        global tclPath
        image create photo helpImage -file ${tclPath}help/$helpFilename__
        label .fmodal.helpscreen.display.lImage -image helpImage
        bind .fmodal.helpscreen.display.lImage <ButtonPress-1> \
                { beepOnce; post $DISP_BTN0_SIG 0 }
        pack .fmodal.helpscreen.display.lImage -fill both -expand yes

        pack .fmodal -fill both -expand yes
    }

    proc actExit {} {
        destroy .fmodal
        image delete helpImage
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Action procedures
    #-------------------------------------------------------------------------
}
