##############################################################################
#
# vc/src/tcl/rmBundleVerWarning.tcl
#
# Roof Module bundle version incopmatibility warning,
#
# 20050525 RCM - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # components) 
    frame .ftop.display         ;# Display Frame
    frame .ftop.input           ;# Input Frame
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes

    # Display Frame - displays up to 3 lines of text
    label .ftop.display.l0 -text " "
    label .ftop.display.l1 -text " " \
                           -font $medium_font
    label .ftop.display.l2 -text " " \
                           -font $medium_font
    label .ftop.display.l3 -text " " \
                           -font $big_font

    # Input frame 
    frame .ftop.input.r1
    SnazzyButton::create .ftop.input.r1.b0 btnKhakiU btnKhakiD 0.2 \
                         "beepOnce; post $DISP_BTN0_SIG 0"

    SnazzyButton::create .ftop.input.r1.b1 btnAcceptU btnAcceptD 0.2 \
                         "beepOnce; post $DISP_BTN1_SIG 1"

    # Cancel button
    SnazzyButton::create .ftop.input.cancel btnKhakiU btnKhakiD 0.5 \
            "beepOnce; post $DISP_BTN9_SIG 9" "Cancel"

    # Exit button
    SnazzyButton::create .ftop.input.exit btnExitKhakiU btnExitKhakiD 0.2 \
                         "beepOnce; post $DISP_BTN9_SIG 9"
#    SnazzyButton::create .ftop.input.exit btnExitKhakiU btnExitKhakiD 0.2 \
#            "beepOnce; guiExit" "Exit"


    # Pack the display and input frames
    pack .ftop.display.l0 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l1 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l2 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l3 -side top -pady 5 -fill both -expand yes
    pack .ftop.input.exit -side left -padx 5 -pady 5 -anchor sw
    pack .ftop.input.r1 -side bottom -anchor se
    pack .ftop.input.r1.b0 -side right -padx 5 -pady 5
    pack .ftop.input.r1.b1 -side right

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { commLbl } {
		global huge_font

        .ftop.display.l0 configure -text $commLbl -font $huge_font
		.ftop.input.exit configure -state disabled
		.ftop.input.r1.b0 configure -state disabled
		.ftop.input.r1.b1 configure -state disabled
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }


# This is used for the system internals menu.  Don't want to
# force the user to exit.
    proc packRMUploadError {returnBtn warningText} {
        global huge_font color3

        SnazzyButton::setText .ftop.input.cancel $returnBtn 0.5
        .ftop.display.l0 configure -text $warningText -font $huge_font

        pack .ftop.input.cancel -side left -padx 5 -pady 5 -anchor sw
        pack .ftop.input.r1 -side bottom -anchor se

        pack .ftop.input.r2 -side bottom -anchor se

        pack .ftop.display.l0 -side top -pady 5

    }


    proc actRMfileError { errLbl actionLbl exitBtn } {
        global huge_font
        global big_font
	
        pack forget .ftop.display.l2
        pack forget .ftop.display.l3
        pack forget .ftop.input.r1.b0
        pack forget .ftop.input.r1.b1

        .ftop.display.l0 configure -text $errLbl -font $huge_font
        .ftop.display.l1 configure -text $actionLbl -font $big_font
        .ftop.input.exit configure -state normal
        SnazzyButton::setText .ftop.input.exit $exitBtn 0.2
    }

    proc actRMverLTbundleVer {ltWarning currBundleVer availBundleVer \
                  continueLbl exitBtn uploadBtn} {

        pack forget .ftop.input.r1.b0

        .ftop.display.l0 configure -text $ltWarning
        .ftop.display.l1 configure -text $currBundleVer
        .ftop.display.l2 configure -text $availBundleVer
        .ftop.display.l3 configure -text $continueLbl
        .ftop.input.exit configure -state normal
        .ftop.input.r1.b1 configure -state normal
        SnazzyButton::setText .ftop.input.exit $exitBtn 0.2
        SnazzyButton::setText .ftop.input.r1.b1 $uploadBtn 0.2
    }

    proc actRMverGTbundleVer { gtWarning okBtn } {
		global big_font

        pack forget .ftop.display.l1
        pack forget .ftop.display.l2
        pack forget .ftop.display.l3
        pack forget .ftop.input.r1.b1
        pack forget .ftop.input.exit

        .ftop.display.l0 configure -text $gtWarning -font $big_font
		.ftop.input.r1.b0 configure -state normal
        SnazzyButton::setText .ftop.input.r1.b0 $okBtn 0.5
    }

    proc actRMverLTbundleVerDriverMode {ltWarning currBundleVer availBundleVer \
                  switchmodeLbl okBtn} {

        pack forget .ftop.input.r1.b1
        pack forget .ftop.input.exit

        .ftop.display.l0 configure -text $ltWarning
        .ftop.display.l1 configure -text $currBundleVer
        .ftop.display.l2 configure -text $availBundleVer
        .ftop.display.l3 configure -text $switchmodeLbl
		.ftop.input.r1.b0 configure -state normal
        SnazzyButton::setText .ftop.input.r1.b0 $okBtn 0.5
    }
    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
