##############################################################################
#
# vc/src/tcl/samPrompt.tcl
#
# Indemnity warning screen,
#
# 20060802 DEH - created
#
# Copyright (c) 2004 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # components) 
    frame .ftop.display         ;# Display Frame
    frame .ftop.input           ;# Input Frame
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes



    # Display Frame - displays up to 3 lines of text
    label .ftop.display.l0
    label .ftop.display.l1
    label .ftop.display.l2
    label .ftop.display.l3
    label .ftop.display.l4

    # Input frame 
    SnazzyButton::create .ftop.input.verify btnGreenU btnGreenD 0.2 \
                         "beepOnce; post $DISP_BTN1_SIG 0"
    SnazzyButton::create .ftop.input.return btnBlueU btnBlueD 0.2 \
                         "beepOnce; post $DISP_BTN0_SIG 0"

    # Pack the display and input frames
    pack .ftop.display.l0 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l1 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l2 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l3 -side top -pady 5 -fill both -expand yes
    pack .ftop.display.l4 -side top -pady 5 -fill both -expand yes
    pack .ftop.input.return -side left -padx 5 -pady 5 -anchor sw
    pack .ftop.input.verify -side right -padx 5 -pady 5 -anchor se

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {title sam warning1 warning2 warning3 exitBtn acceptBtn} {
	global big_font
	global huge_font
        .ftop.display.l0 configure -text $title  -font $big_font -fg "Black"
        .ftop.display.l1 configure -text $sam  -font $big_font
        .ftop.display.l2 configure -text $warning1  -font $huge_font -fg "Blue"
        .ftop.display.l3 configure -text $warning2  -font $big_font -fg "Black"
        .ftop.display.l4 configure -text $warning3  -font $big_font -fg "Black"
        SnazzyButton::setText .ftop.input.return $exitBtn  0.5
        SnazzyButton::setText .ftop.input.verify $acceptBtn 0.5
        pack .ftop -fill both -expand yes

    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }


    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
