##############################################################################
#
# vc/src/tcl/setfw.tcl
#
# Screen to show status of Freewave Channel Set coammnd
#
# 20050513 SSJ - created
#
# Copyright (c) 2005 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Setting Freewave Channel"

    frame .ftop.input
    
    frame .ftop.input.display

    # Display Frame - displays up to 3 lines of text at a time
    label .ftop.input.display.l0 -text "line 0"
    label .ftop.input.display.l1 -text "line 1"

    # Pack .ftop
    pack .ftop.title -side top -pady 10
	pack .ftop.input.display.l0 -side top
	pack .ftop.input.display.l1 -side top
    pack .ftop.input.display -side top -fill both -expand yes
    pack .ftop.input -side top -padx 5 -pady 20
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { scLbl } {
		global big_font

		pack forget .fmodal

        .ftop.title configure -text "Setting Freewave Channel"
        .ftop.input.display.l0 configure -text $scLbl -font $big_font
 
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------
    
	proc actUpdateTimer { tLbl } {
		global big_font

		.ftop.input.display.l1 configure -text $tLbl -font $big_font
	}

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
