##############################################################################
#
# vc/src/tcl/calibImpOffset.tcl
#
# Screen to show SATEL frequencies
#
# 20051115 SSJ - created
#
# Copyright (c) 2005 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Implement Offset Calibration" -font $huge_font

    frame .ftop.input
    frame .ftop.input.display

    # Display Frame - displays up to 1 line(s) of text at a time
    label .ftop.input.display.l0 -text " "
    label .ftop.input.display.l1 -text "Implement Ant Lateral Error:  "

    frame .ftop.input.b
    # Cancel Button
    SnazzyButton::create .ftop.input.b.cancel \
                 btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;"
    pack .ftop.input.b.cancel -side left -padx 5 -anchor w

    # Calib Buttons
    SnazzyButton::create .ftop.input.b.calibStart \
                 btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;"
    pack .ftop.input.b.calibStart -side right -padx 5 -anchor e

    # Pack .ftop
    pack .ftop.title -side top
    pack .ftop.input.b -side bottom -anchor s -fill both
    pack .ftop.input.display.l0 -side top
    pack .ftop.input.display.l1 -side top -pady 20
    pack .ftop.input.display -side top -anchor n -pady 50 -fill both -expand yes
    pack .ftop.input -side bottom 
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {infoLbl errLbl cancelBtn calibStartBtn} {
        global big_font huge_font

        .ftop.input.display.l0 configure -text $infoLbl -font $big_font
        if {$errLbl != "!"} {
          .ftop.input.display.l1 configure -text $errLbl -font $huge_font
        }
        SnazzyButton::setText .ftop.input.b.cancel $cancelBtn 0.5
        SnazzyButton::setText .ftop.input.b.calibStart $calibStartBtn 0.5
 
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

}

