##############################################################################
#
# vc/src/tcl/choosebstype.tcl
#
# Screen to choose basestation type.
#
# 20050502 QC - created
#
# Copyright (c) 2005 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Space for title"

    # Input frame
    frame .ftop.input

    frame .ftop.input.choice0
    radiobutton .ftop.input.choice0.0 -height 2 -width 50 -variable bstype \
        -command {beepOnce; post $DISP_BTN1_SIG 1} -activebackground $color6 \
        -text "INX" -font $big_font -value 0 -anchor sw
    frame .ftop.input.choice16
    radiobutton .ftop.input.choice16.16 -height 2 -width 52 -variable bstype \
        -command {beepOnce; post $DISP_BTN2_SIG 2} -activebackground $color6 \
        -text "CMR" -font $big_font -value 16 -anchor sw
    pack .ftop.input.choice0.0 -side top -padx 30 -anchor sw
    pack .ftop.input.choice16.16 -side top -padx 26 -anchor sw
    pack .ftop.input.choice0 -side top -padx 50 -anchor sw
    pack .ftop.input.choice16 -side top -padx 50 -anchor sw

    # Cancel/Accept frame
    frame .ftop.input2
    SnazzyButton::create .ftop.input2.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN9_SIG 9;" "Return To Previous Menu"
    SnazzyButton::create .ftop.input2.accept btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;" "Accept"            
        
    pack .ftop.input2.cancel -side left -padx 2 -pady 3 -anchor sw
    pack .ftop.input2.accept -side right -padx 2 -pady 3 -anchor se

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    pack .ftop.input -side top -padx 100
    pack .ftop.input2 -side bottom -anchor se -fill x -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl inxLbl cmrLbl returnBtn acceptBtn valbstype} {
        set bstype $valbstype
        .ftop.input.choice$bstype.$bstype select
        
        .ftop.title configure -text $titleLbl
        SnazzyButton::setText .ftop.input2.cancel $returnBtn 0.5
        SnazzyButton::setText .ftop.input2.accept $acceptBtn 0.5
        
        .ftop.input.choice0.0 configure -text $inxLbl
        .ftop.input.choice16.16 configure -text $cmrLbl
        
        pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc actDisplayBsType {valbstype} {
        set bstype $valbstype
        .ftop.input.choice$bstype.$bstype select 
    }

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
