##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Help3Image { 
    frame .help3Image
    label .help3Image.title1 -text "Help" -font $huge_font -justify center
    label .help3Image.title2 -text "Synchronize Base Stations" -font $big_font -justify center

    pack .help3Image.title1 -side top
    pack .help3Image.title2 -side top

    frame .help3Image.r1 -width 600 -height 100
    frame .help3Image.r2 -width 600 -height 100
    frame .help3Image.r3 -width 600 -height 100

    frame .help3Image.r1.btn -width 80 -height 100
    SnazzyUnclippedButton::create .help3Image.r1.btn.img btnBlueM2U btnBlueM2D \
	0.5 "" ""
    frame .help3Image.r1.lbl
    label .help3Image.r1.lbl.label -text "" -font $small_font -justify left
    pack .help3Image.r1.btn -side left
    pack .help3Image.r1.lbl -side right

    frame .help3Image.r2.btn -width 80 -height 100
    SnazzyUnclippedButton::create .help3Image.r2.btn.img btnBlueM2U btnBlueM2D \
	0.5 "" ""
    frame .help3Image.r2.lbl
    label .help3Image.r2.lbl.label -text "" -font $small_font -justify left
    pack .help3Image.r2.btn -side left
    pack .help3Image.r2.lbl -side left

    frame .help3Image.r3.btn -width 80 -height 100
    SnazzyUnclippedButton::create .help3Image.r3.btn.img btnBlueM2U btnBlueM2D \
	0.5 "" ""
    frame .help3Image.r3.lbl
    label .help3Image.r3.lbl.label -text "" -font $small_font -justify left
    pack .help3Image.r3.btn -side left
    pack .help3Image.r3.lbl -side left

    pack .help3Image.r1 -side top -anchor w
    pack .help3Image.r2 -side top -pady 10 -anchor w
    pack .help3Image.r3 -side top -anchor w


    proc actSetImages { image1 image2 image3 } {
	pack forget .help3Image.r1.btn.img
	pack forget .help3Image.r2.btn.img
	pack forget .help3Image.r3.btn.img

	if { $image1 != "!" } {
	    SnazzyUnclippedButton::setImage .help3Image.r1.btn.img $image1 $image1 0.5 
	    pack .help3Image.r1.btn.img -side left -padx 15
	}
	if { $image2 != "!" } {
	    SnazzyUnclippedButton::setImage .help3Image.r2.btn.img $image2 $image2 0.5 
	    pack .help3Image.r2.btn.img -side left -padx 15
	}
	if { $image3 != "!" } {
	    SnazzyUnclippedButton::setImage .help3Image.r3.btn.img $image3 $image3 0.5 
	    pack .help3Image.r3.btn.img -side left -padx 15
	}
    }

    proc actSetStrings { t1 t2 i1 i2 i3 l1 l2 l3} {
	.help3Image.title1 configure -text $t1
	.help3Image.title2 configure -text $t2
	.help3Image.r1.btn.img configure -text ""
	.help3Image.r2.btn.img configure -text ""
	.help3Image.r3.btn.img configure -text ""
	pack forget .help3Image.r1.lbl.label 
	pack forget .help3Image.r2.lbl.label 
	pack forget .help3Image.r3.lbl.label 
	
	if { $i1 != "!" } {
	    .help3Image.r1.btn.img configure -text $i1 
	    #images are packed in actSetImagess
	}
	if { $i2 != "!" } {
	    .help3Image.r2.btn.img configure -text $i2 
	    #images are packed in actSetImagess
	}
	if { $i3 != "!" } {
	    .help3Image.r3.btn.img configure -text $i3 
	    #images are packed in actSetImagess
	}
	if { $l1 != "!" } { 
	    .help3Image.r1.lbl.label configure -text $l1
	    pack .help3Image.r1.lbl.label -side left
	}
	if { $l2 != "!" } { 
	    .help3Image.r2.lbl.label configure -text $l2
	    pack .help3Image.r2.lbl.label -side left
	}
	if { $l3 != "!" } { 
	    .help3Image.r3.lbl.label configure -text $l3
	    pack .help3Image.r3.lbl.label -side left
	}
    }

    proc Exit {} {
	destroy .help3Image
    }
}
