##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval BaseHelp { 
    frame .basehelp

    label .basehelp.title1 -text "Help" -font $huge_font -justify center
    label .basehelp.title2 -text "Synchronize Base Stations" -font $big_font -justify center

    pack .basehelp.title1 -side top
    pack .basehelp.title2 -side top

    label .basehelp.intro1 -text \
	"The \"Synchronize Base Stations\" screen presents the user with\n\
a list of all the base stations that have differences between the\ncompact\
flash disk and the GPS system databases.\n\n" \
	-font $big_font -justify left
    label .basehelp.intro2 -text \
	"Base stations that only exist on the compact flash disk or only on the\nGPS\
system will be displayed once, on the side of the display\ncorresponding\
to their location.\n\n" \
	-font $big_font -justify left
    label .basehelp.intro3 -text \
	"Base stations with the same name that differ in the geographic\n coordinates\
of the station, or that have different associated fields or jobs,\n will be\
displayed on both sides of the display." \
	-font $big_font -justify left

    pack .basehelp.intro1 -side top -pady 5 -anchor w
    pack .basehelp.intro2 -side top -pady 5 -anchor w
    pack .basehelp.intro3 -side top -pady 5 -anchor w

    proc actSetStrings { t1 t2 i1 i2 i3} {
	.basehelp.title1 configure -text $t1
	.basehelp.title2 configure -text $t2
	.basehelp.intro1 configure -text $i1
	.basehelp.intro2 configure -text $i2
	.basehelp.intro3 configure -text $i3
    }

    proc Exit { } {
	destroy .basehelp
    }
}
