##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval BaseHelpInt { 
    frame .basehelpint
    frame .basehelpint.t

    label .basehelpint.t.title1 -text "Help" -font $huge_font -justify center
    label .basehelpint.t.title2 -text "Synchronize Base Stations" -font $big_font -justify center
    label .basehelpint.t.title3 -text "Base Station on GPS System Only" -font $big_font -justify center

    pack .basehelpint.t.title1 -side top
    pack .basehelpint.t.title2 -side top
    pack .basehelpint.t.title3 -side top
    pack .basehelpint.t -side top

    frame .basehelpint.helpdisplay -width 400 -height 350
    pack .basehelpint.helpdisplay  -side right -padx 15 -expand yes -fill both

    frame .basehelpint.buttons -width 150 -height 400
    pack .basehelpint.buttons -side left

    SnazzyButton::create .basehelpint.buttons.toRemote btnBlueM2U btnBlueM2D \
	0.5 "" "<< Copy"

    SnazzyButton::create .basehelpint.buttons.delLocal btnBlueM2U btnBlueM2D \
	0.5 "" "Delete ->"

    SnazzyButton::create .basehelpint.buttons.viewLocal btnBlueM2U btnBlueM2D \
	0.5 "" "View ->"

    pack .basehelpint.buttons.toRemote -side top -anchor w
    pack .basehelpint.buttons.delLocal -side top -anchor w -pady 20
    pack .basehelpint.buttons.viewLocal -side top -anchor w

    label .basehelpint.helpdisplay.l1 -text "1" \
	-font $small_font -justify left -foreground red
    pack .basehelpint.helpdisplay.l1 -side top -anchor nw -pady 10

    label .basehelpint.helpdisplay.l2 -text "2" \
	-font $small_font -justify left -foreground red
    pack .basehelpint.helpdisplay.l2 -side top -anchor nw -pady 10

    label .basehelpint.helpdisplay.l3 -text "3" \
	-font $small_font -justify left -foreground red
    pack .basehelpint.helpdisplay.l3 -side top -anchor nw -pady 10

    label .basehelpint.helpdisplay.l4 -text "4" \
	-font $small_font -justify left -foreground red
    pack .basehelpint.helpdisplay.l4 -side top -anchor nw -pady 10

    label .basehelpint.helpdisplay.l5 -text "5" \
	-font $small_font -justify left -foreground red
    pack .basehelpint.helpdisplay.l5 -side top -anchor nw -pady 10


    proc actSetStrings { t1 t2 t3 b1 b2 b3 l1 l2 l3 l4 l5} {

	#So far these two always exist
	.basehelpint.t.title1 configure -text $t1
	.basehelpint.t.title2 configure -text $t2

	pack forget .basehelpint.t.title3
	pack forget .basehelpint.buttons.toRemote
	pack forget .basehelpint.buttons.delLocal
	pack forget .basehelpint.buttons.viewLocal
	pack forget .basehelpint.helpdisplay.l1
	pack forget .basehelpint.helpdisplay.l2
	pack forget .basehelpint.helpdisplay.l3
	pack forget .basehelpint.helpdisplay.l4
	pack forget .basehelpint.helpdisplay.l5

	if {$t3 != "!"} {
	    .basehelpint.t.title3 configure -text $t3
	    pack .basehelpint.t.title3 -side top
	}
	if {$b1 != "!"} {
	    .basehelpint.buttons.toRemote configure -text $b1
	    pack .basehelpint.buttons.toRemote -side top -anchor w
	}
	if {$b2 != "!"} {
	    .basehelpint.buttons.delLocal configure -text $b2
	    pack .basehelpint.buttons.delLocal -side top -anchor w -pady 20
	}
	if {$b3 != "!"} {
	    .basehelpint.buttons.viewLocal configure -text $b3
	    pack .basehelpint.buttons.viewLocal -side top -anchor w
	}
	if {$l1 != "!"} {
	    .basehelpint.helpdisplay.l1 configure -text $l1
	    pack .basehelpint.helpdisplay.l1 -side top -anchor nw -pady 10
	}
	if {$l2 != "!"} {
	    .basehelpint.helpdisplay.l2 configure -text $l2
	    pack .basehelpint.helpdisplay.l2 -side top -anchor nw -pady 10
	}
	if {$l3 != "!"} {
	    .basehelpint.helpdisplay.l3 configure -text $l3
	    pack .basehelpint.helpdisplay.l3 -side top -anchor nw -pady 10
	}
	if {$l4 != "!"} {
	    .basehelpint.helpdisplay.l4 configure -text $l4
	    pack .basehelpint.helpdisplay.l4 -side top -anchor nw -pady 10
	}
	if {$l5 != "!"} {
	    .basehelpint.helpdisplay.l5 configure -text $l5
	    pack .basehelpint.helpdisplay.l5 -side top -anchor nw -pady 10
	}
    }

    proc Exit { } {
	destroy .basehelpint
    }
}
