##############################################################################
#
# vc/src/tcl/helpscreen.tcl
#
# A modal-dialog-type helpscreen.
#
# 20020625 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Modal { 

    image create photo btnKhakiU -format gif -file \
	${tclPath}gif/btnKhakiU.gif
    image create photo btnKhakiD -format gif -file \
	${tclPath}gif/btnKhakiD.gif
    image create photo bar -format gif -file \
	${tclPath}gif/bar.gif

    frame .fmodal -width 600 -height 450

#     frame .ftop -width 600 -height 450

    SnazzyButton::create .fmodal.back btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN0_SIG 0" "Back"

    SnazzyButton::create .fmodal.more btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN1_SIG 1" "More"

    SnazzyButton::create .fmodal.more2 btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN2_SIG 2" "More"

    SnazzyButton::create .fmodal.more3 btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN3_SIG 3" "More"

    SnazzyButton::create .fmodal.more4 btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN4_SIG 3" "More"

    SnazzyButton::create .fmodal.more5 btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN5_SIG 3" "More"

    SnazzyButton::create .fmodal.more6 btnKhakiU btnKhakiD \
	0.5 "beepOnce; post $DISP_BTN6_SIG 3" "More"

    proc actEntry { helpFilename__ } {
        global tclPath

        pack forget .ftop

	if {[llength $helpFilename__] > 1} {
	    set file [lindex $helpFilename__ 0]
	    set more [lindex $helpFilename__ 1]
	    source ${tclPath}help/$file

	    place .fmodal.back -relx 0 -x 0 -y 450 -anchor sw
	    if { $more == 1 } {
		place .fmodal.more -relx 1 -x -5 -y 450 -anchor se
	    } elseif { $more == 2 } {
		place .fmodal.more2 -relx 1 -x -5 -y 450 -anchor se
	    } elseif { $more == 3 } {
		place .fmodal.more3 -relx 1 -x -5 -y 450 -anchor se
	    } elseif { $more == 4 } {
		place .fmodal.more4 -relx 1 -x -5 -y 450 -anchor se
	    } elseif { $more == 5 } {
		place .fmodal.more5 -relx 1 -x -5 -y 450 -anchor se
	    } elseif { $more == 6 } {
		place .fmodal.more6 -relx 1 -x -5 -y 450 -anchor se
	    }
	    frame .left -width 26 -height 500
	    pack .left -side left
	    pack .fmodal -fill both -expand no -side left
	    frame .right -width 26 -height 500
	    pack .right -side right -expand yes
	} else {
	    image create photo helpImage -file ${tclPath}help/$helpFilename__
	    label .fmodal.lImage -image helpImage
	    bind .fmodal.lImage <ButtonPress-1> \
                { beepOnce; post $DISP_BTN0_SIG 0 }
	    pack .fmodal.lImage -fill both -expand yes
	    pack .fmodal -fill both -expand yes
	}
    }

    proc actExit {} {
	puts "helpscreen exit"
        destroy .left
        destroy .right
	destroy .fmodal
        image delete helpImage
        pack .ftop -fill both -expand yes
    }

    #-------------------------------------------------------------------------
    # Action procedures
    #-------------------------------------------------------------------------
}
