##############################################################################
#
# vc/src/tcl/radiopanel.tcl
#
# Defines packable widgets to facilitate entry of various data types
# 
# 20080319 DEH Created
#
# Copyright (c) 2008 Novariant Inc
# All Rights Reserved. 
##############################################################################


#-------------------------------------------------------------------------
# RadioPanel
#-------------------------------------------------------------------------
namespace eval RadioPanel {

    #-------------------------------------------------------------------------
    # Define and pack the radiopanel
    #-------------------------------------------------------------------------
    # Top level frame
    frame .radiopanel

    # panel text
    frame .radiopanel.left
    label .radiopanel.left.label -text "" -font $small_font

    pack .radiopanel.left.label -side top
    pack .radiopanel.left -side left

    # row and col buttons
    frame .radiopanel.right
    label .radiopanel.l -text ""
    frame .radiopanel.right.r1
    label .radiopanel.right.r1.l -text "1" -font $small_font
    frame .radiopanel.right.r2
    label .radiopanel.right.r2.l -text "2" -font $small_font
    frame .radiopanel.right.r3
    label .radiopanel.right.r3.l -text "3" -font $small_font
    frame .radiopanel.right.r4
    label .radiopanel.right.r4.l -text "4" -font $small_font

    set imgName "btnBlueU"

    SnazzyUnclippedButton::create .radiopanel.right.r1.b1 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r1.b2 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r1.b3 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r2.b1 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r2.b2 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r2.b3 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r3.b1 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r3.b2 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r3.b3 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r4.b1 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r4.b2 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
    SnazzyUnclippedButton::create .radiopanel.right.r4.b3 \
	$imgName $imgName 0.5 "beepOnce; post $DISP_BTN7_SIG 0 \"0\""

    pack .radiopanel.l -side top -pady 1 -expand yes -fill x
    pack .radiopanel.right.r1 -side top  -expand yes -fill x
    pack .radiopanel.right.r2 -side top  -expand yes -fill x
    pack .radiopanel.right.r3 -side top -expand yes -fill x
    pack .radiopanel.right.r4 -side top  -expand yes -fill x
    pack .radiopanel.right -side right

    proc actEntry {} {

   # 4 rows and 3 cols in the screen...
	for {set r 1} {$r < 5} {incr r}{
	    for {set c 1} {$c < 4} {incr r}{
		actAddButton ("", "", $r, $c, "");
            }    
        }
    }

    proc actAddLabel { rowNum labelText } {
	.radiopanel.l configure -text $labelText 
    }

    proc actAddRowLabel { rowNum labelText } {
	.radiopanel.right.r$rowNum.l configure -text $labelText -justify left
	pack .radiopanel.right.r$rowNum.l -side left -padx 5
    }

    proc actRemoveLabel { } {
	.radiopanel.l configure -text "" 
	pack forget radiopanel.1
    }

    proc actAddTextPanel { message } {
	.radiopanel.left.label configure -text $message -justify left
	pack radiopanel.left.label -side left
    }

    proc actRemoveTextPanel { } {
	.radiopanel.left.label configure -text "" 
	pack forget radiopanel.left.label
    }

    proc actAddButton { imgName btnName rowNum colNum value} {
	global DISP_BTN7_SIG
        set cmd "beepOnce; post $DISP_BTN7_SIG $value \"$value\""
	SnazzyUnclippedButton::create .radiopanel.right.r$rowNum.b$colNum \
	    $imgName $imgName 0.5 $cmd
	SnazzyUnclippedButton::setText .radiopanel.right.r$rowNum.b$colNum $btnName 0.5
	pack .radiopanel.right.r$rowNum.b$colNum -side left -padx 5
    }

    proc actCfgButton { imgName btnName rowNum colNum value} {
	global DISP_BTN7_SIG
	set cmd "beepOnce; post $DISP_BTN7_SIG $value \"$value\""

       SnazzyUnclippedButton::setText  .radiopanel.right.r$rowNum.b$colNum $btnName 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r$rowNum.b$colNum $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r$rowNum.b$colNum $imgName $imgName .5

       pack .radiopanel.right.r$rowNum.b$colNum -side left -padx 1
    }

    proc actRemoveLabels {} {
	.radiopanel.right.r1.l configure -text ""
	pack forget .radiopanel.right.r1.l -side left -padx 5
	.radiopanel.right.r2.l configure -text ""
	pack forget .radiopanel.right.r2.l -side left -padx 5
	.radiopanel.right.r3.l configure -text ""
	pack forget .radiopanel.right.r3.l -side left -padx 5
	.radiopanel.right.r4.l configure -text ""
	pack forget .radiopanel.right.r4.l -side left -padx 5
    }

    proc actRemoveButtons { } {
	global DISP_BTN7_SIG
       set cmd "beepOnce; post $DISP_BTN7_SIG 0 \"0\""
       set imgName "btnBlueU"

       SnazzyUnclippedButton::setText  .radiopanel.right.r1.b1 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r1.b1 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r1.b1 $imgName $imgName .5
       pack forget .radiopanel.right.r1.b1

       SnazzyUnclippedButton::setText  .radiopanel.right.r1.b2 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r1.b2 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r1.b2 $imgName $imgName .5
       pack forget .radiopanel.right.r1.b2

       SnazzyUnclippedButton::setText  .radiopanel.right.r1.b3 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r1.b3 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r1.b3 $imgName $imgName .5
       pack forget .radiopanel.right.r1.b3

       SnazzyUnclippedButton::setText  .radiopanel.right.r2.b1 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r2.b1 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r2.b1 $imgName $imgName .5
       pack forget .radiopanel.right.r2.b1

       SnazzyUnclippedButton::setText  .radiopanel.right.r2.b2 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r2.b2 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r2.b2 $imgName $imgName .5
       pack forget .radiopanel.right.r2.b2

       SnazzyUnclippedButton::setText  .radiopanel.right.r2.b3 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r2.b3 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r2.b3 $imgName $imgName .5
       pack forget .radiopanel.right.r2.b3

       SnazzyUnclippedButton::setText  .radiopanel.right.r3.b1 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r3.b1 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r3.b1 $imgName $imgName .5
       pack forget .radiopanel.right.r3.b1

       SnazzyUnclippedButton::setText  .radiopanel.right.r3.b2 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r3.b2 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r3.b2 $imgName $imgName .5
       pack forget .radiopanel.right.r3.b2

       SnazzyUnclippedButton::setText  .radiopanel.right.r3.b3 "" 0.5
       SnazzyUnclippedButton::setCmd   .radiopanel.right.r3.b3 $cmd
       SnazzyUnclippedButton::setImage .radiopanel.right.r3.b3 $imgName $imgName .5
       pack forget .radiopanel.right.r3.b3
    }
}

