##############################################################################
#
# vc/src/tcl/setimezone.tcl
#
# Screen to set time zone.
#
# 20040129 QC - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text "Storm mode Warning:Restart"

    # Cancel/Accept frame
    frame .ftop.input
    SnazzyButton::create .ftop.input.cancel btnKhakiU btnKhakiD 0.5 \
                 "beepOnce; post $DISP_BTN0_SIG 0;" "Return To Previous Menu"
    SnazzyButton::create .ftop.input.accept btnBlueU btnBlueD 0.5 \
                 "beepOnce; post $DISP_BTN1_SIG 1;" "Accept"            
        
    pack .ftop.input.cancel -side left -padx 10 -pady 10
    pack .ftop.input.accept -side right -padx 10 -pady 10

    # Pack .ftop
    pack .ftop.title -side top -pady 10 -fill both -expand yes
    #pack .ftop.input -side top -padx 100
    pack .ftop.input -side bottom -anchor se -fill both -expand yes
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {titleLbl returnBtn acceptBtn stormmod prestormmod } {
       # diagnostics("stormMode actEntry");
        set stormmode $stormmod
        puts stdout "stormmode: $stormmode :$prestormmod"
        set btnid [expr $prestormmod + 5]
        puts stdout "btnid: $btnid"

       # .ftop.title configure -text \
        #                       "$titleLbl (Warning,System will Restart \
        #     PreStormmode = $prestormmod NewStormmode = $stormmod)"
        SnazzyButton::setText .ftop.input.cancel $returnBtn 0.5
        SnazzyButton::setText .ftop.input.accept $acceptBtn 0.5
        
 
       pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

 
    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
