##############################################################################
#
# vc/src/tcl/tooManySams.tcl
#
# Too Many Sams Warning Screen
#
# 20060406 RAA - Created
#
# Copyright (c) 2006 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop

    # Define and pack the screen layout

    # Title
    label .ftop.title -text ""

    
    frame .ftop.display

    # Display Frame - displays up to 2 lines of text at a time
    label .ftop.display.l0 -text "line 0"
    label .ftop.display.l1 -text "line 1"
    label .ftop.display.l2 -text "line 2"

    frame .ftop.input
    # Create frame for buttons
    frame .ftop.input.r1
    SnazzyButton::create .ftop.input.r1.b0 btnBlueU btnBlueD 0.5 \
            "beepOnce; post $DISP_BTN0_SIG 0" "Button 0"
    SnazzyButton::create .ftop.input.r1.b1 btnBlueU btnBlueD 0.5 \
            "beepOnce; post $DISP_BTN1_SIG 1" "Button 1"

    # Pack .ftop
    pack .ftop.title -side top -pady 10
    pack .ftop.input -side bottom -fill both -expand yes -anchor s
    pack .ftop.display -side bottom -fill both -expand yes
    pack .ftop.input.r1 -side bottom -fill both -anchor s
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry { warningTitleLbl warning1Lbl warning2Lbl continueBtn \
                    configBtn } {
      global huge_font big_font

      .ftop.display.l0 configure -text $warningTitleLbl \
                                       -font $huge_font
      pack .ftop.display.l0 -side top
        
      .ftop.display.l1 configure -text $warning1Lbl -font $big_font
                                
      pack .ftop.display.l1 -side top -pady 15
        
      .ftop.display.l2 configure -text $warning2Lbl -font $big_font
                                               
      pack .ftop.display.l2 -side top
        
      SnazzyButton::setText .ftop.input.r1.b0 $continueBtn 0.5
      pack .ftop.input.r1.b0 -side left
 
      SnazzyButton::setText .ftop.input.r1.b1 $configBtn 0.5
      pack .ftop.input.r1.b1 -side right -anchor w
 
      pack .ftop -fill both -expand yes
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

}
