##############################################################################
#
# vc/src/tcl/tractordisptemp.tcl
#
# Temporary implementation of tractor display
#
# 20020612 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################

proc ZoomInTractor {} {

    global autosteerTZoomStatus
    global autosteerZoomXOrig autosteerZoomYOrig
    global autosteerTZoomInXFac autosteerTZoomInYFac
    global autosteerTractorZoomList

    # if not already zoomed in, zoom in
    if { $autosteerTZoomStatus == 0 } {
        set autosteerTZoomStatus 1 
        foreach tag $autosteerTractorZoomList {
            .tractorDisplay.c scale $tag \
                    $autosteerZoomXOrig $autosteerZoomYOrig \
                    $autosteerTZoomInXFac $autosteerTZoomInYFac
        }
    }
}


proc ZoomOutTractor {} {

    global autosteerTZoomStatus
    global autosteerZoomXOrig autosteerZoomYOrig
    global autosteerTZoomOutXFac autosteerTZoomOutYFac
    global autosteerTractorZoomList

    # if not already zoomed out, zoom out
    if { $autosteerTZoomStatus == 1 } {
        set autosteerTZoomStatus 0 
        foreach tag $autosteerTractorZoomList {
            .tractorDisplay.c scale $tag \
                    $autosteerZoomXOrig $autosteerZoomYOrig \
                    $autosteerTZoomOutXFac $autosteerTZoomOutYFac
        }
    }
}


proc ZoomInLines {} {

    global autosteerLZoomStatus
    global autosteerZoomXOrig autosteerZoomYOrig
    global autosteerLZoomInXFac autosteerLZoomInYFac
    global autosteerLinesZoomList
    # if not already zoomed in, zoom in
    if { $autosteerLZoomStatus == 0 } {
        set autosteerLZoomStatus 1 
        foreach tag $autosteerLinesZoomList {
            .tractorDisplay.c scale $tag \
                    $autosteerZoomXOrig $autosteerZoomYOrig \
                    $autosteerLZoomInXFac $autosteerLZoomInYFac
        }
    }
}


proc ZoomOutLines {} {

    global autosteerLZoomStatus
    global autosteerZoomXOrig autosteerZoomYOrig
    global autosteerLZoomOutXFac autosteerLZoomOutYFac
    global autosteerLinesZoomList

    # if not already zoomed out, zoom out
    if { $autosteerLZoomStatus == 1 } {
        set autosteerLZoomStatus 0
        foreach tag $autosteerLinesZoomList {
            .tractorDisplay.c scale $tag \
                    $autosteerZoomXOrig $autosteerZoomYOrig \
                    $autosteerLZoomOutYFac $autosteerLZoomOutYFac
        }
    }
}


proc HideDial {} {

    global autosteerDialStatus
    global autosteerDialTicks autosteerLight autosteerHide

    # if not already hidden, then hide dial and lights
    if { $autosteerDialStatus == 1 } {
        set autosteerDialStatus 0
        foreach tag $autosteerDialTicks {
            .tractorDisplay.c move $tag $autosteerHide $autosteerHide
        }
        .tractorDisplay.c move $autosteerLight $autosteerHide $autosteerHide
    }

}


proc ShowDial {} {

    global autosteerDialStatus
    global autosteerDialTicks autosteerLight autosteerUnhide

    # if hidden, then show dial and lights
    if { $autosteerDialStatus == 0 } {
        set autosteerDialStatus 1
        foreach tag $autosteerDialTicks {
            .tractorDisplay.c move $tag $autosteerUnhide $autosteerUnhide
        }
        .tractorDisplay.c move \
                $autosteerLight $autosteerUnhide $autosteerUnhide
    }
}


proc SetTractorIconCoords { offset } {
    # Set the vertical offset
    global cUpOffset
    set cUpOffset 70

    # Convert the offset from meters to pixels
    set offset [expr 10*$offset]

    # Set the coordinates of the tires
    global cRectX1 cRectY1 cRectX2 cRectY2
    set cRectX1   [expr 90-$offset]
    set cRectY1   [expr 160-$cUpOffset]
    set cRectX2   [expr 110-$offset]
    set cRectY2   [expr 200-$cUpOffset]
    global cFT1X1 cFT1Y1 cFT1X2 cFT1Y2
    set cFT1X1    [expr 85-$offset]
    set cFT1Y1    [expr 160-$cUpOffset]
    set cFT1X2    [expr 88-$offset]
    set cFT1Y2    [expr 168-$cUpOffset]
    global cFT2X1 cFT2Y1 cFT2X2 cFT2Y2
    set cFT2X1    [expr 112-$offset]
    set cFT2Y1    $cFT1Y1
    set cFT2X2    [expr 115-$offset]
    set cFT2Y2    $cFT1Y2
    global cRT1X1 cRT1Y1 cRT1X2 cRT1Y2
    set cRT1X1    [expr 82-$offset]
    set cRT1Y1    [expr 190-$cUpOffset]
    set cRT1X2    [expr 88-$offset]
    set cRT1Y2    [expr 200-$cUpOffset]
    global cRT2X1 cRT2Y1 cRT2X2 cRT2Y2
    set cRT2X1    [expr 112-$offset]
    set cRT2Y1    $cRT1Y1
    set cRT2X2    [expr 118-$offset]
    set cRT2Y2    $cRT1Y2
    global cImplStartX cImplStartY cImplEndX cImplEndY cImplRad
    set cImplStartX [expr ($cRectX1+$cRectX2)/2]
    set cImplStartY $cRectY2
    set cImplEndX [expr ($cRectX1+$cRectX2)/2+$offset]
    set cImplEndY [expr $cRectY2+20]
    set cImplRad 5
}


proc ReconfigTractorIcon { tractorType implWidth tractorColor } {

    puts "begin ReconfigTractorIcon"

    global cRectX1 cRectY1 cRectX2 cRectY2
    global cFT1X1 cFT1Y1 cFT1X2 cFT1Y2
    global cFT2X1 cFT2Y1 cFT2X2 cFT2Y2
    global cImplStartX cImplStartY cImplEndX cImplEndY cImplRad
    global cRT2X1 cRT2Y1 cRT2X2 cRT2Y2
    global cRT1X1 cRT1Y1 cRT1X2 cRT1Y2
    global cUpOffset

    global autosteerTractor
    global gantryLine1 gantryLine2 gantryLine3 gantryLine4
    global autosteerFrontTire1 autosteerFrontTire2
    global autosteerRearTire1 autosteerRearTire2
    global autosteerImplLine autosteerImplDisp

    # Before reconfiguring the tractor icon, make sure that it is zoomed out
    ZoomOutTractor

    # Draw the right kind of tractor
    if { $tractorType == 1 } {
        .tractorDisplay.c coords $autosteerFrontTire1 \
                $cFT1X1 $cFT1Y1 $cFT1X2 $cFT1Y2
        .tractorDisplay.c coords $autosteerFrontTire2 \
                $cFT2X1 $cFT2Y1 $cFT2X2 $cFT2Y2
        .tractorDisplay.c coords $autosteerRearTire1 \
                $cRT1X1 $cRT1Y1 $cRT1X2 $cRT1Y2
        .tractorDisplay.c coords $autosteerRearTire2 \
                $cRT2X1 $cRT2Y1 $cRT2X2 $cRT2Y2
    } elseif { $tractorType == 0 || $tractorType == 2 || \
                   $tractorType == 3 || $tractorType == 5 \
               } {
        set Y1 [expr 175-$cUpOffset]
        set Y2 [expr 200-$cUpOffset]
        .tractorDisplay.c coords $autosteerRearTire1 $cFT1X1 $Y1 $cFT1X2 $Y2
        .tractorDisplay.c coords $autosteerRearTire2 $cFT2X1 $Y1 $cFT2X2 $Y2
        .tractorDisplay.c coords $autosteerFrontTire1 $cFT1X1 $Y1 $cFT1X2 $Y2
        .tractorDisplay.c coords $autosteerFrontTire2 $cFT2X1 $Y1 $cFT2X2 $Y2
    } elseif { $tractorType == 4 } {
        .tractorDisplay.c itemconfigure $autosteerTractor -state hidden 
        .tractorDisplay.c itemconfigure $autosteerImplDisp -state hidden
        .tractorDisplay.c itemconfigure $autosteerImplLine -state hidden
        .tractorDisplay.c itemconfigure $autosteerFrontTire1 -state hidden
        .tractorDisplay.c itemconfigure $autosteerFrontTire2 -state hidden
        .tractorDisplay.c itemconfigure $autosteerRearTire1 -state hidden
        .tractorDisplay.c itemconfigure $autosteerRearTire2 -state hidden

        set x1 [expr $cRT1X1-10]
        set y1 [expr $cFT1Y1-10]
        set x2 [expr $cFT2X1+20]
        set y2 [expr $cFT2Y1-10]
        set x3 [expr $cRT1X1-10]
        set y3 [expr $cRT1Y1+20]
        set x4 [expr $cRT2X1+20]
        set y4 [expr $cRT2Y1+20]
        
        .tractorDisplay.c create line $x1 $y1 $x2 $y2 -width 3 \
                                                           -fill $tractorColor
        .tractorDisplay.c create line $x1 $y1 $x3 $y3 -width 16 \
                                                           -fill $tractorColor
        .tractorDisplay.c create line $x4 $y4 $x4 [expr $y2+($y4-$y2)/2+10] \
                                                  -width 3 -fill $tractorColor
        .tractorDisplay.c create line $x4 [expr $y2+($y4-$y2)/2-10] \
                                $x4 [expr $y2+10] -width 3 -fill $tractorColor
        .tractorDisplay.c create line $x4 $y4 $x3 $y3 -width 3 \
                                                           -fill $tractorColor
        .tractorDisplay.c create rectangle [expr $x1-10] [expr $y1-10] \
                        [expr $x1+10] [expr $y1+10] -fill black -outline black
        .tractorDisplay.c create rectangle [expr $x2-10] [expr $y2-10] \
                        [expr $x2+10] [expr $y2+10] -fill black -outline black
        .tractorDisplay.c create rectangle [expr $x3-10] [expr $y3-10] \
                        [expr $x3+10] [expr $y3+10] -fill black -outline black
        .tractorDisplay.c create rectangle [expr $x4-10] [expr $y4-10] \
                        [expr $x4+10] [expr $y4+10] -fill black -outline black
        .tractorDisplay.c create rectangle [expr $x2-10] \
                                     [expr $y2+($y4-$y2)/2-10] [expr $x2+10] \
             [expr $y2+($y4-$y2)/2+10] -width 3
    } else {
        puts stderr "tractorType had unknown value of $tractorType"
    }

    # Set the color
    global autosteerImplDisp autosteerTractor
    .tractorDisplay.c itemconfigure $autosteerTractor -fill $tractorColor
    .tractorDisplay.c itemconfigure $autosteerImplDisp -fill $tractorColor

    set implWidthMeters $implWidth
    set halfImplWidthPixels [expr 10*$implWidthMeters/2]

    .tractorDisplay.c coords \
            $autosteerTractor $cRectX1 $cRectY1 $cRectX2 $cRectY2
    .tractorDisplay.c coords $autosteerImplLine \
        $cImplStartX $cImplStartY $cImplEndX $cImplEndY
    .tractorDisplay.c coords $autosteerImplDisp \
        [expr $cImplEndX-$halfImplWidthPixels] \
        [expr $cImplEndY] \
        [expr $cImplEndX+$halfImplWidthPixels] \
        [expr $cImplEndY+2*$cImplRad]

    # Reconfigure the ERLM dial
    ShowDial
    global autosteerDialArrow autosteerDialTicks autosteerDialThetas
    .tractorDisplay.c coords $autosteerDialArrow \
            $cImplEndX $cImplEndY $cImplEndX [expr $cRectY1-15]
    set r [expr $cImplEndY-$cRectY1]
    set R [expr $r+10]
    set ii 0
    foreach theta $autosteerDialThetas {
        set ii [expr $ii + 1]
        set x [expr $r*cos($theta)]
        set X [expr $R*cos($theta)]
        set y [expr $r*sin($theta)]
        set Y [expr $R*sin($theta)]
        .tractorDisplay.c coords [lindex $autosteerDialTicks $ii] \
                [expr $cImplEndX+$x] [expr $cImplEndY-$y] \
                [expr $cImplEndX+$X] [expr $cImplEndY-$Y]
    }

    # Check if ELRM is active, and configure accordingly
    global autosteerERLMStatus
    if { $autosteerERLMStatus == 0 } {
        ZoomOutTractor
        HideDial
    } else {
        ShowDial
        ZoomInTractor
    }

    puts "end ReconfigTractorIcon"

}


proc ConfigureTractorIcon { width fanAngle \
        ENHANCED_RLM ERLM_HE_ENTER ERLM_HE_EXIT ERLM_YC_ENTER ERLM_YC_EXIT \
        inTightMode Vx} {

    global cUpOffset
    set xtractor 100
    # The 20 in the next eqn. is the same as the 20 used
    # for the length of the implement in SetTractorIconCoords
    set ytractor [expr 200-$cUpOffset+20]
    global rowPosErr
    set dPixels [expr $rowPosErr*10]  ;#1 pixel approximately equals 10 cm
    set wPixels [expr $width*10]
    set lPixels 200
    global rowHeadingErr

    # Main row
    set cosPsi [expr cos($rowHeadingErr)]
    set sinPsi [expr sin($rowHeadingErr)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr $wPixels * $cosPsi]
    set wsinPsi [expr $wPixels * $sinPsi]
    set lcosPsi [expr $lPixels * $cosPsi]
    set lsinPsi [expr $lPixels * $sinPsi]
    set x1 [expr $xtractor - $dcosPsi + $lsinPsi]
    set y1 [expr $ytractor + $dsinPsi + $lcosPsi]
    set x2 [expr $xtractor - $dcosPsi - $lsinPsi]
    set y2 [expr $ytractor + $dsinPsi - $lcosPsi]

    # Main row arrow
    set cosPsi [expr cos($rowHeadingErr)]
    set sinPsi [expr sin($rowHeadingErr)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr $wPixels * $cosPsi]
    set wsinPsi [expr $wPixels * $sinPsi]
    set lcosPsi [expr 107 * $cosPsi]
    set lsinPsi [expr 107 * $sinPsi]
    set xt1 [expr $xtractor - $dcosPsi + $lsinPsi]
    set yt1 [expr $ytractor + $dsinPsi + $lcosPsi]
    set xt2 [expr $xtractor - $dcosPsi - $lsinPsi]
    set yt2 [expr $ytractor + $dsinPsi - $lcosPsi]

    # Left row 1
    set cosPsi [expr cos($rowHeadingErr+$fanAngle)]
    set sinPsi [expr sin($rowHeadingErr+$fanAngle)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr $wPixels * $cosPsi]
    set wsinPsi [expr $wPixels * $sinPsi]
    set lcosPsi [expr $lPixels * $cosPsi]
    set lsinPsi [expr $lPixels * $sinPsi]
    set x3 [expr $xtractor - $dcosPsi + $lsinPsi - $wcosPsi]
    set y3 [expr $ytractor + $dsinPsi + $lcosPsi + $wsinPsi]
    set x4 [expr $xtractor - $dcosPsi - $lsinPsi - $wcosPsi]
    set y4 [expr $ytractor + $dsinPsi - $lcosPsi + $wsinPsi]

    # Left row 2
    set cosPsi [expr cos($rowHeadingErr+2*$fanAngle)]
    set sinPsi [expr sin($rowHeadingErr+2*$fanAngle)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr 2 * $wPixels * $cosPsi]
    set wsinPsi [expr 2 * $wPixels * $sinPsi]
    set lcosPsi [expr $lPixels * $cosPsi]
    set lsinPsi [expr $lPixels * $sinPsi]
    set x7 [expr $xtractor - $dcosPsi + $lsinPsi - $wcosPsi]
    set y7 [expr $ytractor + $dsinPsi + $lcosPsi + $wsinPsi]
    set x8 [expr $xtractor - $dcosPsi - $lsinPsi - $wcosPsi]
    set y8 [expr $ytractor + $dsinPsi - $lcosPsi + $wsinPsi]

    # Right row 1
    set cosPsi [expr cos($rowHeadingErr-$fanAngle)]
    set sinPsi [expr sin($rowHeadingErr-$fanAngle)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr $wPixels * $cosPsi]
    set wsinPsi [expr $wPixels * $sinPsi]
    set lcosPsi [expr $lPixels * $cosPsi]
    set lsinPsi [expr $lPixels * $sinPsi]
    set x5  [expr $xtractor - $dcosPsi + $lsinPsi + $wcosPsi]
    set y5  [expr $ytractor + $dsinPsi + $lcosPsi - $wsinPsi]
    set x6  [expr $xtractor - $dcosPsi - $lsinPsi + $wcosPsi]
    set y6  [expr $ytractor + $dsinPsi - $lcosPsi - $wsinPsi]

    # Right row 2
    set cosPsi [expr cos($rowHeadingErr-2*$fanAngle)]
    set sinPsi [expr sin($rowHeadingErr-2*$fanAngle)]
    set dcosPsi [expr $dPixels * $cosPsi]
    set dsinPsi [expr $dPixels * $sinPsi]
    set wcosPsi [expr 2 * $wPixels * $cosPsi]
    set wsinPsi [expr 2 * $wPixels * $sinPsi]
    set lcosPsi [expr $lPixels * $cosPsi]
    set lsinPsi [expr $lPixels * $sinPsi]
    set x9  [expr $xtractor - $dcosPsi + $lsinPsi + $wcosPsi]
    set y9  [expr $ytractor + $dsinPsi + $lcosPsi - $wsinPsi]
    set x10 [expr $xtractor - $dcosPsi - $lsinPsi + $wcosPsi]
    set y10 [expr $ytractor + $dsinPsi - $lcosPsi - $wsinPsi]

    global autosteerLineC 
    global autosteerLineL1 autosteerLineR1 autosteerLineL2 autosteerLineR2
    global autosteerLineCArrow
    .tractorDisplay.c coords $autosteerLineC $x1 $y1 $x2 $y2
    .tractorDisplay.c coords $autosteerLineCArrow $xt1 $yt1 $xt2 $yt2
    .tractorDisplay.c coords $autosteerLineL1 $x3 $y3 $x4 $y4
    .tractorDisplay.c coords $autosteerLineR1 $x5 $y5 $x6 $y6
    .tractorDisplay.c coords $autosteerLineL2 $x7 $y7 $x8 $y8
    .tractorDisplay.c coords $autosteerLineR2 $x9 $y9 $x10 $y10
    global autosteerLZoomStatus
    set autosteerLZoomStatus 0  ;# the above effectively unzooms the lines 
                                ;# therefore reset the flag accordingly

    global rowPosErrInch
    set rowPosErrInch [expr $rowPosErr*100.0/2.54]

    # Configure enhanced-row-line-up if necessary
    global autoSteer5XXFlag
    global autosteerERLMStatus 
    global autosteerLight
    global colorGood colorMedium colorBad colorRowlineup colorAutosteer

    # Activate ELRM (enhanced-row-lineup-mode) if entry conditions satisfied
    if { $autosteerERLMStatus == 0 && \
            ( ( ($ENHANCED_RLM == 1 && $autoSteer5XXFlag == 0) || \
            ($ENHANCED_RLM == 2 && $inTightMode == 0) || \
            $ENHANCED_RLM == 3 ) && \
            ($rowHeadingErr > -$ERLM_HE_ENTER && \
            $rowHeadingErr < $ERLM_HE_ENTER) && \
            ($rowPosErr > -$ERLM_YC_ENTER && \
            $rowPosErr < $ERLM_YC_ENTER) )} {
        set autosteerERLMStatus 1
        .tractorDisplay.c itemconfigure $autosteerLineC -width 2 -fill black
        .tractorDisplay.c itemconfigure $autosteerLineCArrow -width 3 \
                -fill black -arrowshape {12 20 8}
        ShowDial
        ZoomInTractor
    } elseif { $autosteerERLMStatus == 1 && \
            ( $ENHANCED_RLM == 0 || \
            ($ENHANCED_RLM == 1 && $autoSteer5XXFlag == 1) || \
            ($ENHANCED_RLM == 2 && $inTightMode == 1 && $Vx > 2.0 ) || \
            ($rowHeadingErr < -$ERLM_HE_EXIT || \
            $rowHeadingErr > $ERLM_HE_EXIT) || \
            ($rowPosErr < -$ERLM_YC_EXIT || \
            $rowPosErr > $ERLM_YC_EXIT) ) } { 
        set autosteerERLMStatus 0
        .tractorDisplay.c itemconfigure $autosteerLineC -width 1 -fill black
        .tractorDisplay.c itemconfigure $autosteerLineCArrow -width 1 \
                -fill black -arrowshape {10 15 6}
        ZoomOutTractor
        HideDial
    }

    # Zoom in on lines and configure line up light if ELRM active
    if { $autosteerERLMStatus == 1 } {
        ZoomInLines
        if { $rowPosErr > -0.05 && $rowPosErr < 0.05 } {
            if { $rowHeadingErr > -0.0167 && $rowHeadingErr < 0.0167 } {
                .tractorDisplay.c itemconfigure $autosteerLight \
                        -fill $colorGood
            } elseif { $rowHeadingErr > -0.0333 && $rowHeadingErr < 0.0333 } {
                .tractorDisplay.c itemconfigure $autosteerLight \
                        -fill $colorMedium
            } else {
                .tractorDisplay.c itemconfigure $autosteerLight \
                        -fill $colorBad
            }
        } elseif { $rowPosErr > -0.1 && $rowPosErr < 0.1 } {
            if { $rowHeadingErr > -0.0333 && $rowHeadingErr < 0.0333 } {
                .tractorDisplay.c itemconfigure $autosteerLight \
                        -fill $colorMedium
            } else {
                .tractorDisplay.c itemconfigure $autosteerLight \
                        -fill $colorBad
            }
        } else {
            .tractorDisplay.c itemconfigure $autosteerLight -fill $colorBad
        }
    }
}


# Configure the velocity display
proc ConfigureVelocityDisplay {text__ Vx__ VxMax__} {
    
    if { $VxMax__ < 0.1 } {
        set VxMax__ 0.1
    }
    set rectPixelPos [expr abs($Vx__)*200.0/$VxMax__]
    if { $rectPixelPos > 200.0 } {
        set rectPixelPos 200.0
    }
    # Set the color of the velocity bar
    if { $Vx__ > $VxMax__ } {
        .tractorDisplay.speedBar itemconfigure Vxbar820 -fill red
    } elseif { $Vx__ > [expr $VxMax__*0.90] } {
        .tractorDisplay.speedBar itemconfigure Vxbar820 -fill yellow
    } else {
        .tractorDisplay.speedBar itemconfigure Vxbar820 -fill green
    }
    .tractorDisplay.speedBar coords Vxbar820 $rectPixelPos 0 0 20
    .tractorDisplay.speedText configure -text $text__
}


# Tractor and implement
SetTractorIconCoords 0.0
set autosteerTractor [.tractorDisplay.c create rectangle \
        $cRectX1 $cRectY1 $cRectX2 $cRectY2 -fill $colorGood -outline black]
set autosteerFrontTire1 [.tractorDisplay.c create rectangle \
        $cFT1X1 $cFT1Y1 $cFT1X2 $cFT1Y2 \
        -fill black -outline black]
set autosteerFrontTire2 [.tractorDisplay.c create rectangle \
        $cFT2X1 $cFT2Y1 $cFT2X2 $cFT2Y2 \
        -fill black -outline black]
set autosteerRearTire1 [.tractorDisplay.c create rectangle \
        $cRT1X1 $cRT1Y1 $cRT1X2 $cRT1Y2 \
        -fill black -outline black]
set autosteerRearTire2 [.tractorDisplay.c create rectangle \
        $cRT2X1 $cRT2Y1 $cRT2X2 $cRT2Y2 \
        -fill black -outline black]

set autosteerImplLine [.tractorDisplay.c create line \
        $cImplStartX $cImplStartY $cImplEndX $cImplEndY]
set autosteerImplDisp [.tractorDisplay.c \
        create rect [expr $cImplEndX-$cImplRad] \
                    [expr $cImplEndY-$cImplRad] \
                    [expr $cImplEndX+$cImplRad] \
                    [expr $cImplEndY+$cImplRad] \
                    -fill $colorGood -outline black]

# Text
set autosteerRowNum [.tractorDisplay.c create text 8 12 -text 0 \
        -anchor w -font $medium_font]
set autosteerNudgeDist [.tractorDisplay.c create text 8 30 -text 0 \
        -anchor w -font $medium_font]
set autosteerManualSteering [.tractorDisplay.c create text 100 190 \
        -text "" -anchor s -font $medium_font]
set autosteerTurboMessage [.tractorDisplay.c create text 100 190 \
        -text "" -anchor s -font $medium_font]

set autosteerTurningWheel [.tractorDisplay.c create text 8 75 \
        -text "" -anchor w -font $medium_font]
set autosteerKillSwitchOn [.tractorDisplay.c create text 8 130 \
        -text "" -anchor w -font $medium_font]
set autosteerMtClutchIn [.tractorDisplay.c create text 192 48 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtInPark [.tractorDisplay.c create text 192 66 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtResetReqd [.tractorDisplay.c create text 192 84 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtRoading [.tractorDisplay.c create text 192 102 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtComsBad [.tractorDisplay.c create text 192 120 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtNotReady [.tractorDisplay.c create text 192 138 \
        -text "" -anchor e -justify right -font $medium_font]
set autosteerMtInxUns [.tractorDisplay.c create text 192 156 \
        -text "" -anchor e -justify right -font $medium_font]

# Dial
set autosteerDialStatus 1;# 0 if hidden, 1 if visible (includes line-up light)
set autosteerDialArrow [.tractorDisplay.c create line \
                        $cImplEndX $cImplEndY $cImplEndX [expr $cRectY1-15] \
                        -fill VioletRed -width 6 -arrow last \
                        -arrowshape {15 25 10}]
set autosteerDialTicks [list $autosteerDialArrow]
set r [expr $cImplEndY-$cRectY1]
set R [expr $r+10]
set autosteerDialThetas \
        {1.1519 1.2566 1.3614 1.4661 1.5708 1.6755 1.7802 1.8850 1.9897}
foreach theta $autosteerDialThetas {
    set x [expr $r*cos($theta)]
    set X [expr $R*cos($theta)]
    set y [expr $r*sin($theta)]
    set Y [expr $R*sin($theta)]
    
    lappend autosteerDialTicks [.tractorDisplay.c create line \
                                [expr $cImplEndX+$x] [expr $cImplEndY-$y] \
                                [expr $cImplEndX+$X] [expr $cImplEndY-$Y] \
                                -fill VioletRed -width 3]
}


# Line-up light
set autosteerLight [.tractorDisplay.c create oval 180 20 195 5 \
                    -fill red -outline black ] 

# Row lines
set autosteerLineC [.tractorDisplay.c create line 90 180 90 0]
set autosteerLineL1 \
        [.tractorDisplay.c create line 90 180 90 0 -stipple gray50]
set autosteerLineR1 \
        [.tractorDisplay.c create line 90 180 90 0 -stipple gray50]
set autosteerLineL2 \
        [.tractorDisplay.c create line 90 180 90 0 -stipple gray50]
set autosteerLineR2 \
        [.tractorDisplay.c create line 90 180 90 0 -stipple gray50]

# Main row arrow
set autosteerLineCArrow [.tractorDisplay.c create line 90 180 90 0 \
                          -fill black -width 1 -arrow last \
                          -arrowshape {10 15 6}]

# Zooming for enhanced-row-line-up mode
set autosteerERLMStatus 0     ;# 0 if off, 1 if on
set autosteerTZoomStatus 0    ;# tractor zoom status: 0 if normal, 1 if zoomed
set autosteerLZoomStatus 0    ;# lines zoom status: 0 if normal, 1 if zoomed
set autosteerZoomXOrig 100
set autosteerZoomYOrig 120
set autosteerTZoomInXFac 2.5  ;# tractor x zoom-in factor
set autosteerTZoomOutXFac [expr 1.0/$autosteerTZoomInXFac]
set autosteerTZoomInYFac 1.75 ;# tractor y zoom-in factor
set autosteerTZoomOutYFac [expr 1.0/$autosteerTZoomInYFac]
set autosteerLZoomInXFac 5    ;# lines x zoom-in factor
set autosteerLZoomOutXFac [expr 1.0/$autosteerLZoomInXFac]
set autosteerLZoomInYFac 1    ;# lines y zoom-in factor
set autosteerLZoomOutYFac [expr 1.0/$autosteerLZoomInYFac]
set autosteerTractorZoomList [list $autosteerTractor \
                                   $autosteerFrontTire1 \
                                   $autosteerFrontTire2 \
                                   $autosteerRearTire1 \
                                   $autosteerRearTire2 \
                                   $autosteerImplLine \
                                   $autosteerImplDisp]
set autosteerTractorZoomList \
        [concat $autosteerTractorZoomList $autosteerDialTicks]
set autosteerLinesZoomList [list $autosteerLineC \
                                 $autosteerLineL1 \
                                 $autosteerLineR1 \
                                 $autosteerLineL2 \
                                 $autosteerLineR2 \
                                 $autosteerLineCArrow]

# When we don't want various items to be visible, we hide them by moving
# them off the visible area of the canvas.
set autosteerHide 1000
set autosteerUnhide -1000

# Job mark 
set autosteerMarkSide 10
set autosteerMark [.tractorDisplay.c create poly \
                   [expr $autosteerHide-$autosteerMarkSide/2] $autosteerHide \
                   [expr $autosteerHide+$autosteerMarkSide/2] $autosteerHide \
                   $autosteerHide [expr $autosteerHide-$autosteerMarkSide] \
                   -fill blue -outline black ] 

# Job mark arrow
set autosteerMarkArrow [.tractorDisplay.c create line 500 500 510 510 \
                        -fill blue -width 1 -arrow last \
                        -arrowshape {10 15 6}]

# Survey mark
set autosteerSurveyMark \
        [.tractorDisplay.c create poly \
            [expr $autosteerHide-$autosteerMarkSide/2] $autosteerHide \
            [expr $autosteerHide+$autosteerMarkSide/2] $autosteerHide \
            $autosteerHide [expr $autosteerHide-$autosteerMarkSide] \
            -fill yellow -outline black ] 
set autosteerSurveyText [.tractorDisplay.c create text \
                         $autosteerHide $autosteerHide \
                         -text "(?,?)" -font $small_font]

HideDial                       ;# MLE run this now to hide the dial at startup

