##############################################################################
#
# sync/src/tcl/selectfield.tcl
#
# Screen to display selectfield selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    # image create photo ExclamationPoint -format gif -file ExclamationPoint.gif

    # screen3 manual menu ........................................................
    frame .ftop -width 604 -height 455

    label .ftop.title -font $huge_font -width 250 \
	-text "Synchronize Fields" -pady 10
    place .ftop.title -relx .5 -y 0 -anchor n

    image create photo btnBlueQuestionU -format gif -file \
	${tclPath}gif/btnBlueQuestionU.gif
    image create photo btnBlueQuestionD -format gif -file \
	${tclPath}gif/btnBlueQuestionD.gif

    SnazzyButton::create .ftop.help btnBlueQuestionU btnBlueQuestionD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" ""

    place .ftop.help -relx 0.97 -y 5 -width 46 -height 46 -anchor ne

    frame .ftop.conflict -width 604 -height 400

    label .ftop.conflict.attention -font $big_font \
	-text "Resolving field issues related to base station "
    place .ftop.conflict.attention -relx .5 -y 10 -anchor n 

    label .ftop.conflict.remoteLbl -text "On Your Sync Disk:" -font $medium_font 
    place .ftop.conflict.remoteLbl -relx 0.20 -y 120 -anchor n

    label .ftop.conflict.localLbl -text "On Your GPS System:" -font $medium_font
    place .ftop.conflict.localLbl -relx 0.80 -y 120 -anchor n

    set canvasX 250
    set canvasY 250

    canvas .ftop.conflict.int -width $canvasX -height $canvasY \
	-relief sunken -borderwidth 1
                   
    canvas .ftop.conflict.ext -width $canvasX -height $canvasY \
	-relief sunken -borderwidth 1

    place .ftop.conflict.ext -relx 0.208 -y 140 -anchor n
    place .ftop.conflict.int -relx 0.792 -y 140 -anchor n
                   
    SnazzyButton::create .ftop.conflict.toLocal btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN1_SIG 1" "Copy >>"

    SnazzyButton::create .ftop.conflict.toRemote btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN2_SIG 2" "<< Copy"

    SnazzyButton::create .ftop.conflict.return btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 9" "Return"

    SnazzyButton::create .ftop.conflict.skip btnBlueM2U btnBlueM2D \
	0.5 "beepOnce; post $DISP_BTN9_SIG 9" "Skip"

    place .ftop.conflict.return -relx 0.501 -y 320 -anchor n

    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {basename fieldname} {
	global huge_font color3

	.ftop.conflict.attention configure -text \
	    "Resolving boundary issues related to base station \"$basename\"\n \
field \"$fieldname\""
	place .ftop.conflict -relx 0.04 -y 50
        pack .ftop -fill both -expand yes
    }


    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
	puts "exit viewfield"
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    proc clearFieldInt {} {
        catch {.ftop.conflict.int delete field}
    }

    proc clearFieldExt {} {
        catch {.ftop.conflict.ext delete field}
    }

    proc actAddIntPoint {n x y area} {
        if {$n == 1} {
           catch {.ftop.conflict.int delete field}
           .ftop.conflict.int create polygon $x $y \
                   -fill green -outline black -tags field
        } else {
           .ftop.conflict.int insert field 0 "$x $y"
        }
    }

    proc actAddExtPoint {n x y area} {
        if {$n == 1} {
           catch {.ftop.conflict.ext delete field}
           .ftop.conflict.ext create polygon $x $y \
                   -fill green -outline black -tags field
        } else {
           .ftop.conflict.ext insert field 0 "$x $y"
        }
    }

    proc actButtonsInternalConflict { entry } {
	puts "actButtonsLocal $entry"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.return -relx 0.501 -y 320 -anchor n
    }

    proc actButtonsInternalConflictSkip { entry } {
	puts "actButtonsLocal $entry"
	place .ftop.conflict.toLocal -relx 0.501 -y 95 -anchor n
	place .ftop.conflict.toRemote -relx 0.501 -y 170 -anchor n
	place .ftop.conflict.skip -relx 0.501 -y 320 -anchor n
    }

    #-------------------------------------------------------------------------
    # Local procedures
    #-------------------------------------------------------------------------

}
