##############################################################################
#
# vc/src/tcl/wizard.tcl
#
# typical wizard screen,
#
# 20080207 JDA - created
#
# Copyright (c) 2008 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftopw

    # Define and pack the screen layout
    # (Screen has custom display and input frames
    # components) 

    frame .ftopw.display         ;# Display Frame
 
    pack .wizardNavigation -in .ftopw -side bottom -anchor sw -expand yes -fill x
    raise .wizardNavigation

    pack .ftopw.display -side bottom -fill x -expand yes

    pack .wizardTopDisplay -in .ftopw -side top -anchor nw -padx 10 -pady 10
    raise .wizardTopDisplay


    # Display Frame - displays up to 3 lines of text
    #label .ftopw.display.l0

  
    # Pack the display and input frames
#    pack .ftopw.display.l0 -side top -pady 5 -fill both -expand yes
 

    
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {title} {

#        .ftopw.display.l0 configure -text $title
        pack .$title -in .ftopw.display
	raise .$title

         pack .ftopw -fill both -expand yes
    }

    proc actEntryNewScreen {title} {
        pack .$title -in .ftopw.display
	raise .$title
	pack .ftopw.display
    }

    proc actForgetScreen {title} {
        pack forget .$title
    }

    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftopw
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

}
