##############################################################################
#
# vc/src/tcl/colorsandfonts.tcl
#
# Define colors, fonts, etc. used by the GUI Tk display
#
# 20020326 MLE - created
#
# Copyright (c) 2002 IntegriNautics Corporation.
# All Rights Reserved. 
##############################################################################

#-----------------------------------------------------------------------------
# Define standard colors (see /usr/lib/X11/rgb.txt for color ideas)
#-----------------------------------------------------------------------------
set color0         #FF0000      ;# Warning Button Color          - Red
set color1         #D3D3D3      ;# Standard Button Color         - Gray
set color2         #70C090      ;# Usually the best choice       - Light Green
set color3         #00BFFF      ;# Generic color used everywhere - Light Blue
set color4         #FFC0CB      ;# Usually not the best choice   - Pink
set color5         "dark khaki" ;# Return to Previous/Main Menu
set color6         "gray85"     ;# Overall background color (original)
set color7         "RoyalBlue1" ;# New button color
set color8         "DeepSkyBlue";# New button color
set color9         "gray"       ;# New button color
set color10        "LightSlateGray" ;# New button color
set colorRowlineup $color4      ;# Canvas background in row lineup mode
set colorAutosteer $color2      ;# Canvas background in autosteer mode
set colorInx       "gray25"     ;# Color of border by logo
set colorVeryGood  "green"      ;# No longer "cornflower blue"
set colorGood      "green"
set colorMedium    "yellow"
set colorBad       "red"
set color0a        #FFC0CB      ;# Active color for color0       - Pink

option add *Frame*background $color6
option add *Label*background $color6
option add *Button*highlightBackground $color6
option add *Button*borderWidth 2
option add *Entry*highlightBackground $color6
option add *Radiobutton*highlightBackground $color6
option add *Listbox*highlightBackground $color6
option add *Scrollbar*highlightBackground $color6
option add *Canvas*highlightBackground $color6

#-----------------------------------------------------------------------------
# Define standard fonts
#-----------------------------------------------------------------------------
set family helvetica
#set family {hp system}
set tiny_font [font create -family $family -weight bold -size -11]
set small_font [font create -family $family -weight bold -size -12]
set medium_font [font create -family $family -weight bold -size -14]
set big_font [font create -family $family -weight bold -size -16]
set btn_font [font create -family $family -weight bold -size -16]
set huge_font [font create -family $family -weight bold -size -24]
option add *Button*font $medium_font
option add *Text*font $medium_font
option add *Label*font $huge_font
option add *Listbox*font $huge_font
option add *Listbox*width 15
option add *Listbox*height 1
option add *Scrollbar*width 50
option add *Entry*font $medium_font
