##############################################################################
#
# vc/src/tcl/softwareupgrade.tcl
#
# Screen to display softwareupgrade selections
#
# RA - created
#
# Copyright (c) 2005 Novariant Corporation.
# All Rights Reserved. 
##############################################################################
namespace eval Screen { 

    #-------------------------------------------------------------------------
    # Define and pack the screen
    #-------------------------------------------------------------------------
    # All screens must create a top level frame .ftop and destroy it on exit
    frame .ftop
    # secret button - disable for now
    #button .ftop.s -height 3 -width 5 \
    #       -command {beepOnce; post $DISP_BTN3_SIG 3 } \
    #       -borderwidth 0 -state normal \
    #       -background $color6 -highlightbackground $color6 \
    #       -activebackground $color6
    #pack .ftop.s -side top -anchor ne
    
    frame .ftop.display         ;# Display Frame
    frame .ftop.input           ;# Input Frame
    pack .ftop.input -side bottom -padx 0 -fill both -expand yes 
    pack .ftop.display -side top -padx 5 -pady 10

    # Exit button
#    button .ftop.input.exit -text "Exit\nProgram" \
#            -width 10 -height 6 \
#            -background $color5 -activebackground $color5 \
#            -command { beepOnce; guiExit }
    label .ftop.display.l0 -text "line 0"
    image create photo gifImage \
            -format gif \
            -file ${tclPath}gif/AFLogo.gif
    label .ftop.display.l1 -image gifImage

    SnazzyButton::create .ftop.input.exit btnExitRedU btnExitRedD 0.2 \
                         "beepOnce; guiExit" "Exit"
    frame .ftop.input.r1
    SnazzyButton::create .ftop.input.r1.b0 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN0_SIG 0" "Full\nInstall"
    SnazzyButton::create .ftop.input.r1.b1 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN1_SIG 1" "Upgrade"
    SnazzyButton::create .ftop.input.r1.b2 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN2_SIG 2" "Backup"
    SnazzyButton::create .ftop.input.r1.b3 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN3_SIG 3" "Restore"
    SnazzyButton::create .ftop.input.r1.b4 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN4_SIG 4" "Language"
    SnazzyButton::create .ftop.input.r1.b5 btnBlueU btnBlueD 0.5 \
                         "beepOnce; post $DISP_BTN4_SIG 5" "OS Freq"

    # pack the exit button
    pack .ftop.input.exit -side left -padx 5 -pady 5 -anchor sw

    pack .ftop.display.l1 -side top -pady 5
                
    #-------------------------------------------------------------------------
    # Standard entry and exit procedures (called by GuiMgr)
    #-------------------------------------------------------------------------
    # Action called by GuiMgr on entry to this screen
    proc actEntry {sysLbl btnFull btnUpgrade btnBackup btnRestore btnLanguage btnOmnistar} {
	global huge_font color3

	.ftop.display.l0 configure -text $sysLbl -font $huge_font

        if {$btnFull != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b0 $btnFull 0.5
          pack .ftop.input.r1.b0 -side right -padx 5 -pady 5 -anchor se 
        }
        if {$btnUpgrade != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b1 $btnUpgrade 0.5
          pack .ftop.input.r1.b1 -side right -padx 5 -pady 5 -anchor se 
        }
        if {$btnBackup != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b2 $btnBackup 0.5
          pack .ftop.input.r1.b2 -side right -padx 5 -pady 5 -anchor se 
        }
        if {$btnRestore != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b3 $btnRestore 0.5
          pack .ftop.input.r1.b3 -side right -padx 5 -pady 5 -anchor se
        }
        if {$btnLanguage != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b4 $btnLanguage 0.5
          pack .ftop.input.r1.b4 -side right -padx 5 -pady 5 -anchor se
        }
	if {$btnOmnistar != "!"} {
	  SnazzyButton::setText .ftop.input.r1.b5 $btnOmnistar 0.5
          pack .ftop.input.r1.b5 -side right -padx 5 -pady 5 -anchor se
	}
        
	pack .ftop.input.r1 -padx 0 -side bottom -anchor se
	pack .ftop.display.l0 -side top -pady 5
        pack .ftop -fill both -expand yes

    }



    # Action called by GuiMgr on exit from this screen
    proc actExit {} {
        destroy .ftop
    }

    #-------------------------------------------------------------------------
    # Screen action procedures (to be called by GuiMgr)
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Delegated procedures
    #-------------------------------------------------------------------------

    #-------------------------------------------------------------------------
    # Local procedures
    # {MLE-020418: Tcl/Tk goal should be to get rid of all local procedures, 
    # because they represent intelligence, which the display should not have.}
    #-------------------------------------------------------------------------
    # Local procedures
}
